<?php
error_reporting(E_ERROR | E_PARSE);

include 'isdk.php';

$MyApp = new iSDK;
$MyApp->cfgCon("purchase");



//http://test.test/rockwell/address_fixer.php?contactId=1204898
$contactId = intval($_POST['contactId']);

if(!$contactId){
	exit;
}
function addressFormatter($address){
	$address = str_replace('+', ' ', $address);
	$address = trim($address);
	return preg_replace('!\s+!', ' ', $address);
}

function stateFormatter($state){

	$stateList = array('AL'=>"Alabama",
		'AK'=>"Alaska",
		'AZ'=>"Arizona",
		'AR'=>"Arkansas",
		'CA'=>"California",
		'CO'=>"Colorado",
		'CT'=>"Connecticut",
		'DE'=>"Delaware",
		'DC'=>"District Of Columbia",
		'FL'=>"Florida",
		'GA'=>"Georgia",
		'HI'=>"Hawaii",
		'ID'=>"Idaho",
		'IL'=>"Illinois",
		'IN'=>"Indiana",
		'IA'=>"Iowa",
		'KS'=>"Kansas",
		'KY'=>"Kentucky",
		'LA'=>"Louisiana",
		'ME'=>"Maine",
		'MD'=>"Maryland",
		'MA'=>"Massachusetts",
		'MI'=>"Michigan",
		'MN'=>"Minnesota",
		'MS'=>"Mississippi",
		'MO'=>"Missouri",
		'MT'=>"Montana",
		'NE'=>"Nebraska",
		'NV'=>"Nevada",
		'NH'=>"New Hampshire",
		'NJ'=>"New Jersey",
		'NM'=>"New Mexico",
		'NY'=>"New York",
		'NC'=>"North Carolina",
		'ND'=>"North Dakota",
		'OH'=>"Ohio",
		'OK'=>"Oklahoma",
		'OR'=>"Oregon",
		'PA'=>"Pennsylvania",
		'RI'=>"Rhode Island",
		'SC'=>"South Carolina",
		'SD'=>"South Dakota",
		'TN'=>"Tennessee",
		'TX'=>"Texas",
		'UT'=>"Utah",
		'VT'=>"Vermont",
		'VA'=>"Virginia",
		'WA'=>"Washington",
		'WV'=>"West Virginia",
		'WI'=>"Wisconsin",
		'WY'=>"Wyoming",
		//Canada
		"BC" => "British Columbia",
		"ON" => "Ontario",
		"NL" => "Newfoundland and Labrador",
		"NS" => "Nova Scotia",
		"PE" => "Prince Edward Island",
		"NB" => "New Brunswick",
		"QC" => "Quebec",
		"MB" => "Manitoba",
		"SK" => "Saskatchewan",
		"AB" => "Alberta",
		"NT" => "Northwest Territories",
		"NU" => "Nunavut",
		"YT" => "Yukon Territory",



		);

	$stateListAdditions = [
		"Alberta" => "AB",
		"Colombie-Britannique" => "BC",
		"Manitoba" => "MB",
		"Nouveau-Brunswick" => "NB",
		"Terre-Neuve-et-Labrador" => "NL",
		"Nouvelle-Écosse" => "NS",
		"Territoires du Nord-Ouest" => "NT",
		"Nunavut" => "NU",
		"Ontario" => "ON",
		"Île-du-Prince-Édouard" => "PE",
		"Québec" => "QC",
		"Saskatchewan" => "SK",
		"Yukon" => "YT"
	];

	$checkState = preg_replace('/[^a-zA-Z0-9 \s -]/', '', $state);
	$checkState = preg_replace('!\s+!', ' ', $checkState);
	$checkState = trim($checkState);

	$twoLetters = preg_replace('/[^\w]/', '', $checkState);

	if(strlen($twoLetters) == 2){
		$state = strtoupper($twoLetters);
	}else{
		$state = addressFormatter($checkState);

		foreach($stateList as $stateCode => $stateName){
			if(strtolower($state) == strtolower($stateName)){
				return $stateCode;
			}
		}

		if(strlen($state) > 2){

			foreach($stateListAdditions as $stateName => $stateCode){
				if(strtolower($state) == strtolower($stateName)){
					return $stateCode;
				}
			}

		}
	}

	return $state;


}

function fixPhone($country, $phone){
	if($country == 'United States' && substr($phone,0,1) === '+'){

		$prefix = '+1';


		if (substr($phone, 0, strlen($prefix)) == $prefix) {

			$phone = substr($phone, strlen($prefix));

		}
	}
	return $phone;
}

$returnFields = array('StreetAddress1', 'StreetAddress2', 'City','City2', 'State', 'Country', 'Phone1', 'Phone2', 'Address2Street1', 'Address2Street2', 'State2');
$conDat = $MyApp->loadCon($contactId, $returnFields);


$fixedAddress = [];

//address1
$fixedAddress['StreetAddress1'] = ucwords(addressFormatter($conDat['StreetAddress1']));
$fixedAddress['Address2Street1'] = ucwords(addressFormatter($conDat['Address2Street1']));

//address2
$fixedAddress['StreetAddress2'] = ucwords(addressFormatter($conDat['StreetAddress2']));
$fixedAddress['Address2Street2'] = ucwords(addressFormatter($conDat['Address2Street2']));

//state
$fixedAddress['State'] = stateFormatter($conDat['State']);
$fixedAddress['State2'] = stateFormatter($conDat['State2']);

//city
$fixedAddress['City'] = ucwords(addressFormatter($conDat['City']));
$fixedAddress['City2'] = ucwords(addressFormatter($conDat['City2']));


//phone1
$fixedAddress['Phone1'] = fixPhone($conDat['Country'],$conDat['Phone1']);

//phone2
$fixedAddress['Phone2'] = fixPhone($conDat['Country'],$conDat['Phone2']);


$conID = $MyApp->updateCon($contactId, $fixedAddress);