<?php
error_reporting(E_ERROR | E_PARSE);
$contactId = intval($_POST['contactId']);

if(!$contactId){
	exit;
}

function addressFormatter($address){
	$address = str_replace('+', ' ', $address);
	$address = trim($address);
	return preg_replace('!\s+!', ' ', $address);
}

function stateFormatter($state){

	$stateList = array('AL'=>"Alabama",
		'AK'=>"Alaska",
		'AZ'=>"Arizona",
		'AR'=>"Arkansas",
		'CA'=>"California",
		'CO'=>"Colorado",
		'CT'=>"Connecticut",
		'DE'=>"Delaware",
		'DC'=>"District Of Columbia",
		'FL'=>"Florida",
		'GA'=>"Georgia",
		'HI'=>"Hawaii",
		'ID'=>"Idaho",
		'IL'=>"Illinois",
		'IN'=>"Indiana",
		'IA'=>"Iowa",
		'KS'=>"Kansas",
		'KY'=>"Kentucky",
		'LA'=>"Louisiana",
		'ME'=>"Maine",
		'MD'=>"Maryland",
		'MA'=>"Massachusetts",
		'MI'=>"Michigan",
		'MN'=>"Minnesota",
		'MS'=>"Mississippi",
		'MO'=>"Missouri",
		'MT'=>"Montana",
		'NE'=>"Nebraska",
		'NV'=>"Nevada",
		'NH'=>"New Hampshire",
		'NJ'=>"New Jersey",
		'NM'=>"New Mexico",
		'NY'=>"New York",
		'NC'=>"North Carolina",
		'ND'=>"North Dakota",
		'OH'=>"Ohio",
		'OK'=>"Oklahoma",
		'OR'=>"Oregon",
		'PA'=>"Pennsylvania",
		'RI'=>"Rhode Island",
		'SC'=>"South Carolina",
		'SD'=>"South Dakota",
		'TN'=>"Tennessee",
		'TX'=>"Texas",
		'UT'=>"Utah",
		'VT'=>"Vermont",
		'VA'=>"Virginia",
		'WA'=>"Washington",
		'WV'=>"West Virginia",
		'WI'=>"Wisconsin",
		'WY'=>"Wyoming",
		//Canada
		"BC" => "British Columbia",
		"ON" => "Ontario",
		"NL" => "Newfoundland and Labrador",
		"NS" => "Nova Scotia",
		"PE" => "Prince Edward Island",
		"NB" => "New Brunswick",
		"QC" => "Quebec",
		"MB" => "Manitoba",
		"SK" => "Saskatchewan",
		"AB" => "Alberta",
		"NT" => "Northwest Territories",
		"NU" => "Nunavut",
		"YT" => "Yukon Territory",



	);

	$stateListAdditions = [
		"Alberta" => "AB",
		"Colombie-Britannique" => "BC",
		"Manitoba" => "MB",
		"Nouveau-Brunswick" => "NB",
		"Terre-Neuve-et-Labrador" => "NL",
		"Nouvelle-Écosse" => "NS",
		"Territoires du Nord-Ouest" => "NT",
		"Nunavut" => "NU",
		"Ontario" => "ON",
		"Île-du-Prince-Édouard" => "PE",
		"Québec" => "QC",
		"Saskatchewan" => "SK",
		"Yukon" => "YT"
	];

	$checkState = preg_replace('/[^a-zA-Z0-9 \s -]/', '', $state);
	$checkState = preg_replace('!\s+!', ' ', $checkState);
	$checkState = trim($checkState);

	$twoLetters = preg_replace('/[^\w]/', '', $checkState);

	if(strlen($twoLetters) == 2){
		$state = strtoupper($twoLetters);
	}else{
		$state = addressFormatter($checkState);

		foreach($stateList as $stateCode => $stateName){
			if(strtolower($state) == strtolower($stateName)){
				return $stateCode;
			}
		}

		if(strlen($state) > 2){

			foreach($stateListAdditions as $stateName => $stateCode){
				if(strtolower($state) == strtolower($stateName)){
					return $stateCode;
				}
			}

		}
	}

	return $state;


}

function fixPhone($country, $phone){
	if($country == 'United States' && substr($phone,0,1) === '+'){

		$prefix = '+1';


		if (substr($phone, 0, strlen($prefix)) == $prefix) {

			$phone = substr($phone, strlen($prefix));

		}
	}
	return $phone;
}

require_once dirname( dirname(__FILE__) ).'/isdk.php';
$MyApp = new iSDK;
$MyApp->cfgCon("purchase");

function getCountryCode($country){

	$csv = array_map('str_getcsv', file('countries_csv.csv'));
	$code = $country;
	$isFound = false;


	foreach($csv as $singleLine){
		if(strtolower($singleLine[0]) == strtolower($country)){
			$code = $singleLine[1];
			$isFound = true;
			break;
		}
	}

	return $isFound ? strtoupper($code) : $isFound;
}

//2 - shipping, 1 - billing
$returnFields = array('Country','Country2', 'City', 'City2', 'StreetAddress1', 'StreetAddress2', 'Address2Street1', 'Address2Street2', 'PostalCode', 'PostalCode2', 'State', 'State2', 'LastName', 'FirstName', 'Phone1');
$conDat = $MyApp->loadCon($contactId, $returnFields);
if(!$conDat['Country'] && !$conDat['Country2']){
	http_response_code(400);
	exit;
}


$country = $city = $conDat['Country2'] ? $conDat['Country2'] : $conDat['Country'];
$city = $conDat['City2'] ? $conDat['City2'] : $conDat['City'];
$address = $conDat['Address2Street1'] ? $conDat['Address2Street1'] : $conDat['StreetAddress1'];
$address2 = $conDat['Address2Street2'] ? $conDat['Address2Street2'] : $conDat['StreetAddress2'];
$postal = $conDat['PostalCode2'] ? $conDat['PostalCode2'] : $conDat['PostalCode'];
$state = $conDat['State2'] ? $conDat['State2'] : $conDat['State'];
$firstName = $conDat['FirstName'];
$lastName = $conDat['LastName'];
$phone = $conDat['Phone1'];
$countryCode = getCountryCode($country);




$returnFields = array('Id','ProductSold','InvoiceTotal','TotalPaid','DateCreated','JobId');
$query = array('ContactId' => $contactId, 'ProductSold' => '%634%', 'TotalPaid' => '~>~ 0');
$invoices = $MyApp->dsQuery("Invoice", 10,0, $query, $returnFields);
$latestIndex = count($invoices)-1;
$jobId = $invoices[$latestIndex]['JobId'];

if(!$jobId){
	http_response_code(400);
	exit;
}

$returnFieldsJob = ['ShipCity','ShipCountry','ShipPhone', 'ShipFirstName', 'ShipLastName', 'ShipStreet1', 'ShipStreet2', 'ShipZip', 'ShipState'];
$queryJob = ['Id' => $jobId];
$jobs = $MyApp->dsQuery("Job", 10,0, $queryJob, $returnFieldsJob)[0];

$shipCountry = getCountryCode($jobs['ShipCountry']);
$countryCode =  $shipCountry ? $shipCountry : $countryCode;
$address = $jobs['ShipStreet1'] ? $jobs['ShipStreet1'] : $address;
$address2 = $jobs['ShipStreet2'] ? $jobs['ShipStreet2'] : $address2;
$city = $jobs['ShipCity'] ? $jobs['ShipCity'] : $city;
$postal = $jobs['ShipZip'] ? $jobs['ShipZip'] : $postal;
$state = $jobs['ShipState'] ? $jobs['ShipState'] : $state;
$firstName = $jobs['ShipFirstName'] ? $jobs['ShipFirstName'] : $firstName;
$lastName = $jobs['ShipLastName'] ? $jobs['ShipLastName'] : $lastName;
$phone = $jobs['ShipPhone'] ? $jobs['ShipPhone'] : $phone;



if(!$countryCode || !$city || !$address){
	http_response_code(400);
	exit;
}

$data = [
	'CountryCode' => trim($countryCode),
	'InvoiceId' => $invoices[$latestIndex]['Id'],
	'OrderDate' => $invoices[$latestIndex]['DateCreated'],
	'TotalPaid' => $invoices[$latestIndex]['TotalPaid'],
	'InvoiceTotal' => $invoices[$latestIndex]['InvoiceTotal'],
	'ProductIds' => $invoices[$latestIndex]['ProductSold'],
	'Address' => utf8_encode(addressFormatter($address)),
	'Address2' => utf8_encode(addressFormatter($address2)),
	'City' => utf8_encode(ucfirst(strtolower(addressFormatter($city)))),
	'Postal' => $postal,
	'State' => utf8_encode(stateFormatter($state)),
	'FirstName' => utf8_encode(ucfirst(strtolower($firstName))),
	'LastName' => utf8_encode(ucfirst(strtolower($lastName))),
	'Phone' => $phone
];
echo (json_encode($data)); exit;

//1324952

//634 - PXS, 636 - guide

//http://test.test/rockwell/book/get_book.php?contactId=1204898

//http://test.test/rockwell/book/get_book.php?contactId=208919