<?php
error_reporting(0);

$contactId = intval($_POST['contactId']);
if(!$contactId){
	exit;
}

require __DIR__ . '/vendor/autoload.php';
require_once 'isdk.php';

//if (php_sapi_name() != 'cli') {
//	throw new Exception('This application must be run on the command line.');
//}

/**
 * Returns an authorized API client.
 * @return Google_Client the authorized client object
 */
function getClient()
{


	$client = new Google_Client();

	$client->setApplicationName('Google Calendar API PHP Quickstart');
	$client->setScopes(Google_Service_Calendar::CALENDAR_READONLY);
	$client->setAuthConfig('credentials.json');
	$client->setAccessType('offline');
	$client->setPrompt('select_account consent');


	// Load previously authorized token from a file, if it exists.
	// The file token.json stores the user's access and refresh tokens, and is
	// created automatically when the authorization flow completes for the first
	// time.
	$tokenPath = 'token.json';
	if (file_exists($tokenPath)) {
		$accessToken = json_decode(file_get_contents($tokenPath), true);
		$client->setAccessToken($accessToken);
	}

	// If there is no previous token or it's expired.
	if ($client->isAccessTokenExpired()) {
		// Refresh the token if possible, else fetch a new one.

		if ($client->getRefreshToken()) {
			$client->fetchAccessTokenWithRefreshToken($client->getRefreshToken());

		} else {
			// Request authorization from the user.
			$authUrl = $client->createAuthUrl();
			printf("Open the following link in your browser:\n%s\n", $authUrl);
			print 'Enter verification code: ';
			$authCode = trim(fgets(STDIN));

			// Exchange authorization code for an access token.
			$accessToken = $client->fetchAccessTokenWithAuthCode($authCode);
			$client->setAccessToken($accessToken);

			// Check to see if there was an error.
			if (array_key_exists('error', $accessToken)) {
				throw new Exception(join(', ', $accessToken));
			}
		}
		// Save the token to a file.
		if (!file_exists(dirname($tokenPath))) {
			mkdir(dirname($tokenPath), 0700, true);
		}
		file_put_contents($tokenPath, json_encode($client->getAccessToken()));
	}
	return $client;
}

function runCalendarAPI(){
	// Get the API client and construct the service object.

	$client = getClient();



	$service = new Google_Service_Calendar($client);

	/*
	$calendarList = $service->calendarList->listCalendarList();

	while(true) {
		foreach ($calendarList->getItems() as $calendarListEntry) {
			echo $calendarListEntry->id."\n";
			echo $calendarListEntry->summary."\n\n";

		}
		$pageToken = $calendarList->getNextPageToken();
		if ($pageToken) {
			$optParams = array('pageToken' => $pageToken);
			$calendarList = $service->calendarList->listCalendarList($optParams);
		} else {
			break;
		}
	}*/


// Print this weeks events on the user's calendar.

	$today = date("Y-m-d\TH:i:sP");
	$plusFive = strtotime("+5 day");
	$plusFive = date("Y-m-d\TH:i:sP", $plusFive);

	$calendarId = 'omrleve3s62vdaqjf99m4aabn8@group.calendar.google.com';
	$optParams = array(
		'orderBy' => 'startTime',
		'singleEvents' => true,
		'timeMin' => $today,
		'timeMax' => $plusFive
	);

	$results = $service->events->listEvents($calendarId, $optParams);

	$events = $results->getItems();

	$numberOfCheckIn = 0;
	$numberOfFundamentals = 0;



	if (!empty($events)) {
		foreach ($events as $event) {
			$start = $event->start->dateTime;
			if (empty($start)) {
				$start = $event->start->date;
			}

			$summary = $event->getSummary();

			if (strpos($summary, 'Fundamentals') !== false) {
				$numberOfFundamentals++;
			}

			if (strpos($summary, 'Check in') !== false) {
				$numberOfCheckIn++;
			}
//		printf("%s (%s)\n", $event->getSummary(), $start);
		}
	}


	if($numberOfFundamentals > 0 && $numberOfCheckIn > 1){
		return true;
	}else{
		return false;
	}
}

//simple caching
$latestCall = file_get_contents('latest-call.txt');

if($latestCall){
	$data = unserialize($latestCall);
}

if($data->date != date('Y-m-d')){
	$data = new stdClass();

	$data->date = date('Y-m-d');

	$data->access = runCalendarAPI();

	$dataSerialized = serialize($data);
	file_put_contents('latest-call.txt',$dataSerialized);
}




$canAccessTag = 13022;
$cantAccessTag = 13024;
$MyApp = new iSDK;
$MyApp->cfgCon("purchase");

if($data->access){
	$MyApp->grpAssign($contactId, $canAccessTag);
}else{
	$MyApp->grpAssign($contactId, $cantAccessTag);
}



