<?php
include 'isdk.php';

class Redirector {

	public $noAccess = 'https://www.rockwelltrading.com/day-trading/members/access-denied/';
	public $actions = ['monday','tuesday','thursday','fundamentals','vbr'];

	public $mondayAccessTag = 10369; //50-14 - Mondays Access
	public $mondayHideTag = 10703; //Hide Mondays
	public $mondayLink = 'https://www.rockwelltrading.com/mondaymorningcoaching-call';

	public $tuesdayAccessTag = 11678; //50-24 - Tuesdays Access
	public $tuesdayHideTag = 11680; //Hide Tuesdays
	public $tuesdayLink = 'https://www.rockwelltrading.com/tuesdaycoaching-call';

	public $thursdayAccessTag = 11688; //50-25 - Thursday Access
	public $thursdayHideTag = 11690; //	Hide Thursdays
	public $thursdayLink = 'https://www.rockwelltrading.com/thursdaycoaching-call';

	public $fundamentalsAccessTag = 10427; //50-23 - Rockwell Fundamentals Access
	public $fundamentalsHideTag = 10836; //Hide Fundamentals
	public $fundamentalsLink = 'https://www.rockwelltrading.com/fundamentalscoaching-call';

	public $VBRAccessTag = 10367; //30-33 - VB Access
	public $VBRHideTag = 9463; // MM Exclude from Virtual Boardroom
	public $VBRLink = 'https://www.rockwelltrading.com/vbrcoacnhing-call';

	public $mmTag = 5284; //WP - RWT Mastermind
	public $mmLiteTag = 11702; // WP - RWT Mastermind - Lite
	public $mmInactiveTag = 9695; //MasterMind Inactive

	public function redirectTo($access,$link){
		if($access){
			header('location:'.$link);
		}else{

			header('location:'.$this->noAccess);
		}
		return true;
	}

	//http://test.test/rockwell/mm-redir.php?cid=1204898&action=thursday

	public function redirectPattern($contactTags,$specialAccessTag,$hideTag){
		$tags = explode(',',$contactTags);
		$intTags = [];
		foreach($tags as $tag){
			$intTags[] = intval($tag);
		}
		$tags = $intTags;
		unset($intTags);


		if(in_array($specialAccessTag,$tags)){
			return true;
		}

		if(in_array($hideTag,$tags)){
			return false;
		}

		if(!in_array($this->mmTag,$tags) && !in_array($this->mmLiteTag,$tags) ){
			return false;
		}

		if(in_array($this->mmInactiveTag,$tags)){
			return false;
		}
		return true;
	}

	public function mondayCanAccess($contactTags){
		return $this->redirectPattern($contactTags,$this->mondayAccessTag,$this->mondayHideTag);
	}

	public function tuesdayCanAccess($contactTags){
		return $this->redirectPattern($contactTags,$this->tuesdayAccessTag,$this->tuesdayHideTag);
	}

	public function fundamentalsCanAccess($contactTags){
		return $this->redirectPattern($contactTags,$this->fundamentalsAccessTag,$this->fundamentalsHideTag);
	}

	public function thursdayCanAccess($contactTags){
		return $this->redirectPattern($contactTags,$this->thursdayAccessTag,$this->thursdayHideTag);
	}

	public function VBRCanAccess($contactTags){
		return $this->redirectPattern($contactTags,$this->VBRAccessTag,$this->VBRHideTag);
	}
}

$redirector = new Redirector();


if(!intval($_GET['cid']) || !in_array($_GET['action'],$redirector->actions)){
	$redirector->redirectTo(false,$redirector->noAccess);
	exit;
}

$contactId = intval($_GET['cid']);
$MyApp = new iSDK;
$MyApp->cfgCon("purchase");

//1204898

$returnFields = array('Email', 'Groups');
$conDat = $MyApp->loadCon($contactId, $returnFields);

if(!is_array($conDat)){
	$redirector->redirectTo(false,$redirector->noAccess);
	exit;
}

$contactTags = $conDat['Groups'];

switch ($_GET['action']){
	case 'monday':
		$redirector->redirectTo($redirector->mondayCanAccess($contactTags),$redirector->mondayLink);
		break;
	case 'tuesday':
		$redirector->redirectTo($redirector->tuesdayCanAccess($contactTags),$redirector->tuesdayLink);
		break;
	case 'fundamentals':
		$redirector->redirectTo($redirector->fundamentalsCanAccess($contactTags),$redirector->fundamentalsLink);
		break;
	case 'thursday':
		$redirector->redirectTo($redirector->thursdayCanAccess($contactTags),$redirector->thursdayLink);
		break;
	case 'vbr':
		$redirector->redirectTo($redirector->VBRCanAccess($contactTags),$redirector->VBRLink);
		break;
}