<?php

class Contact_Tracker{
	protected $ifs;
	protected $db;
	protected $TagsTableName = 'tags';
	protected $ContactsTableName = 'leads';
	protected $tagFields = ['ContactId','DateCreated','GroupId'];
	protected $leadFields = ['Id','_EntryPoint','_firstutmsource','_firstutmcampaign','_firstutmmedium', '_firstutmtarget','_firstutmcontent','Leadsource','DateCreated'];
	public $tagsToGet = [
		8867, // ebook
		13630,// options 101
		14008,// checklist
		12358,// pxs form
		12350,// pxs order
		12520,// pxo attended webinar
		11552,// scheduled a tour
		11554,// attended a tour
		10970 // pxo sale
	];


	public function __construct($ifs) {
		$this->ifs = $ifs;
		//database
		$this->host = 'ls-42d5fb9b07a5403f05981bfaac9fb4eb1dfef9e3.cusuqabgs2a3.us-east-1.rds.amazonaws.com';
		$this->db   = 'datastudio';
		$this->user = 'dbmasteruser';
		$this->pass = 'fOETsA{g$]p0>vlg!n>}`RKXd_!vh%08';
		$this->charset = 'utf8mb4';
		$this->dsn = "mysql:host=$this->host;dbname=$this->db;charset=$this->charset";
	}

	protected function dataStudioDate($ifsDate){
		$dateSt = strtotime($ifsDate);
		$dateDS = date('Ymd',$dateSt);
		return $dateDS;
	}

	protected function removeContact($contactId){
		$pdo = new PDO($this->dsn, $this->user, $this->pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$sql = "DELETE FROM `leads` WHERE `contactId` = ".$contactId;
		$pdo->exec($sql);
		unset ($pdo);
		return true;
	}

	protected function removeTagByContact($contactId){
		$pdo = new PDO($this->dsn, $this->user, $this->pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$sql = "DELETE FROM `tags` WHERE `contactId` = ".$contactId;
		$pdo->exec($sql);
		unset ($pdo);
		return true;
	}

	protected function getContact($contactId){
		$conDat = $this->ifs->loadCon($contactId, $this->leadFields);
		if(!$conDat){
			return false;
		}
		foreach($this->leadFields as $field){
			if(!isset($conDat[$field])){
				$conDat[$field] = '';
			}
		}
		$conDat['DateCreated'] = $this->dataStudioDate($conDat['DateCreated']);
		return $conDat;
	}

	protected function getTagsByContact($contactId){
		$returnFields = getNumberOfTagIterations;
		$query = ['ContactId' => $contactId, 'GroupId' => $this->tagsToGet]; //'TotalPaid'=>'~<>~0'
		$howMany = count($this->tagsToGet);
		$tags = $this->ifs->dsQuery("ContactGroupAssign",$howMany,0,$query,$returnFields,'Id');
		if(!$tags){
			return false;
		}
		$updatedContacts = [];
		foreach($tags as $tag){
			$updatedContacts[$tag['GroupId']] = $tag;
			$updatedContacts[$tag['GroupId']]['DateCreated'] = $this->dataStudioDate($updatedContacts[$tag['GroupId']]['DateCreated']);
		}
		return $updatedContacts;
	}

	protected function addContact($contact){
		$pdo = new PDO($this->dsn, $this->user, $this->pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$contact['_EntryPoint'] = $pdo->quote($contact['_EntryPoint']);
		$contact['_firstutmsource'] = $pdo->quote($contact['_firstutmsource']);
		$contact['_firstutmcampaign'] = $pdo->quote($contact['_firstutmcampaign']);
		$contact['_firstutmmedium'] = $pdo->quote($contact['_firstutmmedium']);
		$contact['_firstutmtarget'] = $pdo->quote($contact['_firstutmtarget']);
		$contact['_firstutmcontent'] = $pdo->quote($contact['_firstutmcontent']);
		$contact['Leadsource'] = $pdo->quote($contact['Leadsource']);
		$contact['DateCreated'] = $pdo->quote($contact['DateCreated']);

		$query = 'INSERT INTO `'.$this->ContactsTableName.'` (`contactId`,`entryPoint`,`first_utm_source`,`first_utm_campaign`,`first_utm_medium`,`first_utm_target`, `first_utm_content`, `leadsource`,`dateCreated`) VALUES ';
		$valuesString = "(".$contact['Id'].",".$contact['_EntryPoint'].",".$contact['_firstutmsource'].",".$contact['_firstutmcampaign'].",".$contact['_firstutmmedium'].",".$contact['_firstutmtarget'].",".$contact['_firstutmcontent'].",".$contact['Leadsource'].",".$contact['DateCreated'].")";
		$query.= $valuesString;
		try {
			$pdo->exec($query);
		} catch(PDOException $e) {
			return $e->getMessage();
		}
		unset ($pdo);
		return true;
	}

	protected function addTags($tags){
		$pdo = new PDO($this->dsn, $this->user, $this->pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$query = 'INSERT INTO `'.$this->TagsTableName.'` (`tagId`,`contactId`,`dateApplied`) VALUES ';
		foreach($tags as $tag){
			$tag['DateCreated'] = $pdo->quote($tag['DateCreated']);
			$valuesString = "(".$tag['GroupId'].",".$tag['ContactId'].",".$tag['DateCreated']."),";
			$query.= $valuesString;
		}
		$query = rtrim($query,',');
		try {
			$pdo->exec($query);
		} catch(PDOException $e) {
			return $e->getMessage();
		}
		unset ($pdo);
		return true;
	}



	public function getLastContactIdFromTags($whichTag){
		$pdo = new PDO($this->dsn, $this->user, $this->pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

		//Get last Id
		$sth = $pdo->prepare("SELECT max(contactId) as Id FROM ".$this->TagsTableName. " WHERE tagId =".$whichTag);
		$sth->execute();
		$result = $sth->fetch(PDO::FETCH_ASSOC);
		$contactId = intval($result['Id']);
		if(!$contactId){
			$contactId = false;
		}
		unset ($pdo);
		return $contactId;
	}

	public function getLastContactIdFromLeads(){
		$pdo = new PDO($this->dsn, $this->user, $this->pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

		//Get last Id
		$sth = $pdo->prepare("SELECT max(contactId) as Id FROM ".$this->ContactsTableName);
		$sth->execute();
		$result = $sth->fetch(PDO::FETCH_ASSOC);
		$contactId = intval($result['Id']);
		if(!$contactId){
			$contactId = false;
		}
		unset ($pdo);
		return $contactId;
	}

	public function loadTags($tagId, $lastContact = false){
		$query = ['GroupId' => $tagId, 'DateCreated' => '~>=~ 2020-01-01 00:00:00']; //'TotalPaid'=>'~<>~0' DateCreated => '~>=~ 2020-01-01 00:00:00'
		if($lastContact){
			$query['ContactId'] = '~>~ '.$lastContact;
		}
		return $this->ifs->dsQuery("ContactGroupAssign",1000,0,$query,$this->tagFields,'ContactId');
	}

	public function getNumberOfTagIterations($tagId, $lastContact = false){
		$query = ['GroupId' => $tagId, 'DateCreated' => '~>=~ 2020-01-01 00:00:00']; //'TotalPaid'=>'~<>~0' DateCreated => '~>=~ 2020-01-01 00:00:00'
		if($lastContact){
			$query['ContactId'] = '~>~ '.$lastContact;
		}
		$numberOfIt = $this->ifs->dsCount("ContactGroupAssign",$query);
		$numberOfIt = intval(ceil($numberOfIt/1000));
		return $numberOfIt;
	}

	public function uploadTags($tags){
		$pdo = new PDO($this->dsn, $this->user, $this->pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

		$query = 'INSERT INTO `'.$this->TagsTableName.'` (`tagId`,`contactId`,`dateApplied`) VALUES ';
		foreach($tags as $tag){
			$tag['DateCreated'] = $pdo->quote($this->dataStudioDate($tag['DateCreated']));
			$valuesString = "(".$tag['GroupId'].",".$tag['ContactId'].",".$tag['DateCreated']."),";
			$query.= $valuesString;
		}
		$query = rtrim($query,',');
		try {
			$pdo->exec($query);
		} catch(PDOException $e) {
			return $e->getMessage();
		}
		unset ($pdo);
		return true;
	}

	public function getLeadsIterations($lastContact = false){
		$pdo = new PDO($this->dsn, $this->user, $this->pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$query = 'SELECT COUNT(DISTINCT contactId) AS iterations FROM '.$this->TagsTableName;
		if($lastContact){
			$query = 'SELECT COUNT(DISTINCT contactId) AS iterations FROM '.$this->TagsTableName. ' WHERE contactId>'.$lastContact;
		}
		$sth = $pdo->prepare($query);
		$sth->execute();
		$result = $sth->fetch(PDO::FETCH_ASSOC);
		$numberOfIt = intval($result['iterations']);
		$numberOfIt = intval(ceil($numberOfIt/1000));
		return $numberOfIt;
	}

	public function getContactIds($lastContact = false){
		$pdo = new PDO($this->dsn, $this->user, $this->pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$query = 'SELECT DISTINCT contactId FROM '.$this->TagsTableName. " ORDER BY contactId ASC LIMIT 1000";
		if($lastContact){
			$query = "SELECT DISTINCT contactId FROM ".$this->TagsTableName. " WHERE contactId>".$lastContact. " ORDER BY contactId ASC LIMIT 1000";
		}
		$sth = $pdo->prepare($query);
		$sth->execute();
		$result = $sth->fetchAll(PDO::FETCH_ASSOC);
		$ids = [];
		foreach($result as $contact){
			$ids[] = intval($contact['contactId']);
		}
		return $ids;
	}


	public function getIFSLeads($contactIds){
		$query = ['Id' => $contactIds];
		$leads = $this->ifs->dsQuery("Contact",1000,0,$query,$this->leadFields,'Id');

		$cleanLeads = [];
		foreach($leads as $lead){
			foreach($this->leadFields as $field){
				if(!isset($lead[$field])){
					$lead[$field] = '';
				}
			}
			$lead['DateCreated'] = $this->dataStudioDate($lead['DateCreated']);
			$lead['contactId'] = $lead['Id'];
			unset($lead['Id']);
			$cleanLeads[] = $lead;
		}
		return $cleanLeads;

	}

	public function uploadLeads($IFScontacts){
		$pdo = new PDO($this->dsn, $this->user, $this->pass);
		$pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
		$query = 'INSERT INTO `'.$this->ContactsTableName.'` (`contactId`,`entryPoint`,`first_utm_source`,`first_utm_campaign`,`first_utm_medium`,`first_utm_target`, `first_utm_content`, `leadsource`,`dateCreated`) VALUES ';
		$valuesString = '';
		foreach($IFScontacts as $IFScontact){
			$IFScontact['_EntryPoint'] = $pdo->quote($IFScontact['_EntryPoint']);
			$IFScontact['_firstutmsource'] = $pdo->quote($IFScontact['_firstutmsource']);
			$IFScontact['_firstutmcampaign'] = $pdo->quote($IFScontact['_firstutmcampaign']);
			$IFScontact['_firstutmmedium'] = $pdo->quote($IFScontact['_firstutmmedium']);
			$IFScontact['_firstutmtarget'] = $pdo->quote($IFScontact['_firstutmtarget']);
			$IFScontact['_firstutmcontent'] = $pdo->quote($IFScontact['_firstutmcontent']);
			$IFScontact['Leadsource'] = $pdo->quote($IFScontact['Leadsource']);
			$IFScontact['DateCreated'] = $pdo->quote($IFScontact['DateCreated']);
			$valuesString .= "(".$IFScontact['contactId'].",".$IFScontact['_EntryPoint'].",".$IFScontact['_firstutmsource'].",".$IFScontact['_firstutmcampaign'].",".$IFScontact['_firstutmmedium'].",".$IFScontact['_firstutmtarget'].",".$IFScontact['_firstutmcontent'].",".$IFScontact['Leadsource'].",".$IFScontact['DateCreated']."),";
		}
		$valuesString = rtrim($valuesString,',');
		$query.= $valuesString;

		try {
			$pdo->exec($query);
		} catch(PDOException $e) {
			return $e->getMessage();
		}
		unset ($pdo);
		return true;
	}


	public function syncContact($contactId){
		$this->removeContact($contactId);
		$this->removeTagByContact($contactId);
		$contact = $this->getContact($contactId);
		$this->addContact($contact);
		$tags = $this->getTagsByContact($contactId);
		$this->addTags($tags);
		return true;
	}


}