<?php
Class Navigation{
    protected $logo = '/includes/images/logotext.png';
    protected $adminHome = '/admin/';
    protected $mainHome = '/';
    public $which = false;
    protected $adminNavigation = array(
        'Registrants' => array(
            'access'=>'10,20,30,40,50',
            'link' => '/event/',
        ),
        'Settings' => array(
            'link' => '#',
            'access'=>'10',
            'child' => array(
                'Bootcamp Tag Settings' => array(
                    'link' => '/settings/',
                    'access'=>'10'
                ),
                'Live Event Tag Settings' => array(
                    'link' => '/settings/summit/',
                    'access'=>'10'
                ),
                'Mastermind Tag Settings' =>[
                    'access' => '10',
                    'link' => '/settings/mastermind/'
                ]
            )
        ),
        'Other Tools' => array(
            'link' => '#',
            'access'=>'10',
            'child' => array(
                'Bulk Tag Application' => array(
                 'link' => '/applytag/',
                  'access'=>'10'
                ),
                'Leadsource Processor' => [
                    'link' => '/leadsource/',
                    'access'=>'10'
                ],
                'Tagger' => [
                    'link' => '/tag/creator/',
                    'access'=>'10'
                ],
                'Bootcamp Tracking' => [
                    'link' => '/tracker/',
                    'access'=>'10'
                ]
            )
        ),
        'Mastermind' => array(
            'link' => '#',
            'access'=>'10',
            'child' => [
                'List' =>[
                    'access' => '10',
                    'link' => '/mastermind/'
                ]
            ]
        ),
        'Users' => array(
            'link' => '#',
            'access'=>'10',
            'child' => array(
                'User List' =>array(
                    'access'=>'10',
                    'link'=>'/user/'
                ),
                'Create User' =>array(
                    'access'=>'10',
                    'link'=>'/user/create/'
                )
//                'Managers' =>array(
//                    'access'=>'10',
//                    'link'=>'/manager/'
//                )
            )
        ),
        'Logout' =>
        array(
            'access' => 'all',
            'link' => '/logout/'
        )
    );
    protected $mainNavigation = array(
        'Original Content' => array(
          'link' => '/oc/'
        )
    );

    public function __construct(){
        $this->utility = new Utility();
        return true;
    }

    public function renderNavigation($which = 'main'){

        $user =  Current::getCurrent()->getUser();
        $logo = '';
        if($this->logo){
            $logo = '<li class="logo"><a class="navbar-brand" href="'.$this->adminHome.'"><img src="'.$this->logo.'" width="auto" height="30" class="d-inline-block align-top" alt=""></a></li>';
        }

        if ($this->which !==false ){
            $which = $this->which;
        }
        if($which == 'admin'){
            $nav = $this->adminNavigation;
            $navClass = 'navbar navbar-admin navbar-light';
            $home = $this->adminHome;
        }elseif($which == 'none'){
            echo '';
            return true;
        }else{
            $nav = $this->mainNavigation;
            $navClass = 'navbar navbar-custom';
            $home = $this->mainHome;
        }
        $active = Current::getActiveNav();
        $childActive = false;
        $output = '<div class="container-fluid navbar-admin">
    <div class="container">

        <!-- Brand and toggle get grouped for better mobile display -->

        <!-- Collect the nav links, forms, and other content for toggling -->
          <ul class="nav nav-light">'.$logo;
        foreach($nav as $menuTitle => $item){

            $isAllowedParent = $this->utility->checkUserPermissions($user,$item['access']);

            if ($item['link'] == $active && empty($item['child']) && $isAllowedParent ){
                $output.= '<li class="nav-item"><a class="nav-link active" href="'.$item['link'].'">'.$menuTitle.' <span class="sr-only">(current)</span></a></li>';
            }elseif(!empty($item['child']) && $isAllowedParent){

                /**
                 * Check if child is active
                 */
                $childActive = '';
                foreach($item['child'] as $childTitle => $childItem){
                    if($childItem['link'] == $active){
                        $childActive = 'active';
                    }
                }
                $output.='<li class="nav-item dropdown '.$childActive.'">
                        <a class="nav-link dropdown-toggle" href="#" data-toggle="dropdown" role="button" aria-haspopup="true"
                       aria-expanded="false">'.$menuTitle.'</a> <ul class="dropdown-menu">';
                foreach($item['child'] as $childTitle => $childItem){
                    $childActive = '';
                    $isAllowedChild = $this->utility->checkUserPermissions($user,$childItem['access']);
                    if($childItem['link'] == $active){
                        $childActive = 'class="active"';
                    }
                    if($isAllowedChild){
                        $output.='<li '.$childActive.'><a class="dropdown-item" href="'.$childItem['link'].'">'.$childTitle.'</a></li>';
                    }
                }
                $output.='</ul></li>';
            }elseif($isAllowedParent){
                $output.=' <li class="nav-item"><a class="nav-link" href="'.$item['link'].'">'.$menuTitle.'</a></li>';
            }else{
                $output.='';
            }
        }
        $output.='</ul></div></div>';
        echo $output;
        return true;
    }
}