<?php
Class event extends Controller{

	public $ajax = false;

	public function __construct() {
		parent::__construct();
		$this->ajax = new ajax();
		return true;
	}

	public function index(){
		$user = Current::getCurrent()->getUser();
		$isAllowed = $this->utility->checkUserPermissions($user,'10,20,30,40');
		if(!$isAllowed){
			View::set404();
			return false;
		}
		$tpl = 'event-list';
		$data = $this->model->getEvents();
		$bootOnlyPermissions = $this->utility->checkUserPermissions($user,'30');
		if($bootOnlyPermissions){
			$tpl = 'event-select';
			$data = $this->model->getEvents(false,'boot');
		}
		$summitOnly = $this->utility->checkUserPermissions($user,'40');
		if($summitOnly) {
			$tpl = 'event-select';
			$data = $this->model->getEvents(false, 'live');
		}
		$managerOnly = $this->utility->checkUserPermissions($user,'20');
		if($managerOnly){
			$tpl = 'event-select';
			$data = $this->model->getEvents();
		}

		$this->view->title = 'Choose an event';
		$this->view->eventList();
		$this->view->setLayout('admin');
		$this->view->render($tpl,$data);
		return true;
	}

	public function create(){

		$user = Current::getCurrent()->getUser();
		$isAllowed = $this->utility->checkUserPermissions($user,'10');
		if(!$isAllowed){
			View::set404();
			return false;
		}
		if(!$this->model->ajax->checkAjax()){
			$this->view->setLayout('admin');
			$tag = new model_tag();
			$this->view->tags = $tag->getTags(false);
			$this->view->eventCreate();
			$this->view->render('event-create');
			return true;
		}else{
			$this->model->createEvent();
			return true;
		}
	}

	public function update(){
		$user = Current::getCurrent()->getUser();
		$isAllowed = $this->utility->checkUserPermissions($user,'10');
		if(!$isAllowed){
			View::set404();
			return false;
		}
		if(!$this->model->ajax->checkAjax()){
			$this->view->id = $this->utility->getArgument(0);
			$data = $this->model->getEvents($this->view->id);
			if(empty($data)){
				View::set404();
				return false;
			}
			$data = $data[$this->view->id];
			$this->view->setLayout('admin');
			$tag = new model_tag();
			$this->view->tags = $tag->getTags(false);
			$this->view->eventUpdate();
			$this->view->render('event-update',$data);
			return true;
		}else{
			$this->model->updateEvent();
			return true;
		}
	}

	public function remove(){
		$user = Current::getCurrent()->getUser();
		$isAllowed = $this->utility->checkUserPermissions($user,'10');
		if(!$isAllowed){
			View::set404();
			return false;
		}
		if (!$this->ajax->model->checkAjax()){
			View::set404();
			return false;
		}
		$this->model->removeEvent();
		return true;
	}

}