<?php
Class manager extends Controller{

    public $ajax = false;

    public function __construct() {
        parent::__construct();
        $this->ajax = new ajax();
        return true;
    }

    public function index(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        $data = $this->model->getManagers();
        $this->view->setLayout('admin');
        $this->view->managerList();
        $this->view->title = 'Sales Managers';
        $this->view->render('manager-list',$data);
        return true;
    }

    public function create(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        if(!$this->model->ajax->checkAjax()){
            $data = $this->model->getManagers();
            $this->view->setLayout('admin');
            $this->view->managerCreate();
            $this->view->title = 'Create a new Manager';
            $this->view->render('manager-create',$data);
            return true;
        }else{
            $this->model->createManager();
            return true;
        }
    }

    public function update(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        $this->view->id = $this->utility->getArgument(0);
        if(!$isAllowed || ( !$this->view->id && !$this->model->ajax->checkAjax() ) ){
            View::set404();
            return false;
        }
        if(!$this->model->ajax->checkAjax()){
            $this->view->id = $this->utility->getArgument(0);
            $data = $this->model->getManagers();
            $this->view->manager = $data[$this->view->id];
            $this->view->setLayout('admin');
            $this->view->managerUpdate();
            $this->view->title = 'Update a Manager';
            $this->view->render('manager-update');
            return true;
        }else{
            $this->model->updateManager();
            return true;
        }
    }

    public function remove(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        if (!$this->ajax->model->checkAjax()){
            View::set404();
            return false;
        }
        $this->model->removeManager();
        return true;
    }

}