<?php
Class mastermind extends Controller {

    public function __construct(){
        parent::__construct();
    }

    public function index(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        $data = $this->model->index();
        $this->view->state = $data['state'];
        $this->view->masterminds = $data['masterminds'];
        $this->view->showTagBtn = empty($this->view->state) || !$this->view->state['mmtagID'] || !$this->view->state['mmCallTag'];
        $this->view->showListBtn = !$this->view->showTagBtn && empty($this->view->masterminds);
        $this->view->setLayout('admin');
        $this->view->registrants();
        $this->view->render('mmcall',$data);
        return true;
    }

    public function lb(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10,50,20');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        $data = $this->model->index();
        $this->view->state = $data['state'];
        $this->view->masterminds = $data['masterminds'];
        $this->view->showTagBtn = empty($this->view->state) || !$this->view->state['mmtagID'] || !$this->view->state['mmCallTag'];
        $this->view->showListBtn = !$this->view->showTagBtn && empty($this->view->masterminds);
        $this->view->setLayout('admin');
        $this->view->lb();
        $this->view->render('mmlb',$data);
        return true;
    }

    public function syncMMList(){
        if (!$this->model->ajax->checkAjax()){
            View::set404();
            return false;
        }
        $tagId = intval($_POST['tagID']);
        $this->model->syncMasterminds($tagId);
        return true;
    }
}