<?php
Class registrants extends Controller{

	public $ajax = false;

	public function __construct() {
		parent::__construct();
		$this->ajax = new ajax();
		return true;
	}

	public function show(){
		$user = Current::getCurrent()->getUser();
		$isAllowed = $this->utility->checkUserPermissions($user,'10,20,30,40');
		$id = intval($this->utility->getArgument(0));
		$event_arr = false;

		if($id){
			$events = new event();
			$event_arr = $events->model->getEvents($id);
		}

		if(!$isAllowed || !$id ||!$event_arr){
			View::set404();
			return false;
		}
		$data = $this->model->registrants($id);
		$this->view->registrants = $data['registrants'];
		$this->view->sessions = $data['sessions'];
		$this->view->state = $data['state'];
		$event = array_values($event_arr)[0];
		$this->view->closest = $this->model->closestSession($this->view->sessions);

		//title init
		$title = $event->title;
		$type = $event->type;
		$registrationTag = $event->tagId;
		$this->view->buttons = [];
		$this->view->useGlobal = $event->useGlobal;

		//bootcamp
		if ($type == 'boot'){

			//use global
			if($event->useGlobal){
				$this->view->buttons['attendTag'] = $event->attendedTag.','.$data['state']['attendTag'];
				$this->view->buttons['addNewContactTag'] = $event->attendedTag.','.$data['state']['addNewTag'].','.$registrationTag;
				$this->view->buttons['softwareLow'] = $event->liveTag ? $event->purchasedTag.','.$event->liveTag : $event->purchasedTag;
				$this->view->buttons['softwareHigh'] = $this->view->buttons['softwareLow'];
				$this->view->buttons['softwareLow'] = $data['state']['softwareLow']?$this->view->buttons['softwareLow'].','.$data['state']['softwareLow']:false;
				$this->view->buttons['softwareHigh'] = $data['state']['softwareHigh']?$this->view->buttons['softwareHigh'].','.$data['state']['softwareHigh']:false;
			}else{
				$this->view->buttons['attendTag'] = $event->attendedTag;
				$this->view->buttons['addNewContactTag'] = $event->attendedTag.','.$registrationTag;
				$this->view->buttons['purchasedTag'] = $event->liveTag ? $event->purchasedTag.','.$event->liveTag : $event->purchasedTag;
				$this->view->buttons['softwareLow'] = $event->liveTag ? $event->purchasedTag.','.$event->liveTag : $event->purchasedTag;
				$this->view->buttons['softwareHigh'] = $this->view->buttons['softwareLow'];
			}
			$this->view->buttons['pendingTag'] = $data['state']['pendingTag'];

			$this->view->showTagBtn =
				!$this->view->buttons['attendTag']
				|| !$this->view->buttons['softwareHigh']
				|| !$this->view->buttons['pendingTag']
				|| !$this->view->buttons['softwareLow'];
		}

		//live buttons
		if($type == 'live'){

			//use global
			if($event->useGlobal){
				$this->view->buttons['attendTag'] = $event->attendedTag.','.$data['state']['attendTagSummit'];
				$this->view->buttons['addNewContactTag'] = $event->attendedTag.','.$data['state']['addNewTagSummit'].','.$registrationTag;
				$this->view->buttons['innerCircleStart'] = $event->purchasedTag.','.$data['state']['innerCircleStart'];
				$this->view->buttons['diamondStartTag'] = $event->purchasedTag.','.$data['state']['diamondStartTag'];
				$this->view->buttons['diamondLifetimeStartTag'] = $event->purchasedTag.','.$data['state']['diamondLifetimeStartTag'];
				$this->view->buttons['platStartTag'] = $event->purchasedTag.','.$data['state']['platStartTag'];
				$this->view->buttons['goldStartTag'] = $event->purchasedTag.','.$data['state']['goldStartTag'];
				$this->view->buttons['silverStartTag'] = $event->purchasedTag.','.$data['state']['silverStartTag'];
			}else{
				$this->view->buttons['attendTag'] = $event->attendedTag;
				$this->view->buttons['addNewContactTag'] = $event->attendedTag.','.$registrationTag;
				$this->view->buttons['innerCircleStart'] = $event->purchasedTag;
				$this->view->buttons['diamondStartTag'] = $event->purchasedTag;
				$this->view->buttons['diamondLifetimeStartTag'] = $event->purchasedTag;
				$this->view->buttons['platStartTag'] = $event->purchasedTag;
				$this->view->buttons['goldStartTag'] = $event->purchasedTag;
				$this->view->buttons['silverStartTag'] = $event->purchasedTag;
			}

//			$this->view->buttons['regTicketTag']=$data['state']['regTicketTag'];
			$this->view->buttons['vipTicketTag']=$event->vipTag;

			$this->view->showTagBtn =
				!$this->view->buttons['attendTag']
				|| !$this->view->buttons['addNewContactTag']
				|| !$this->view->buttons['innerCircleStart']
				|| !$this->view->buttons['diamondStartTag']
				|| !$this->view->buttons['diamondLifetimeStartTag']
				|| !$this->view->buttons['platStartTag']
				|| !$this->view->buttons['goldStartTag']
				|| !$this->view->buttons['silverStartTag'];

		}
		$this->view->buttons['sendText'] = $data['state']['sendText'];
		$this->view->buttons['reviewText'] = $data['state']['reviewText'];

		$this->view->eventId = $id;
		$this->view->showListBtn = !$this->view->showTagBtn && empty($this->view->registrants);
		$this->view->setLayout('admin');
		$this->view->title = $title;

		switch ($type){
			case 'live':
				$this->view->registrantsLive();
				$this->view->render('registrants-summit',$data);
				break;
			case 'boot':
				$this->view->registrants();
				$this->view->render('registrants',$data);
				break;
			default:
				$this->view->registrants();
				$this->view->render('registrants',$data);
		}

		return true;
	}

	public function syncRegList(){
		if (!$this->model->ajax->checkAjax()){
			View::set404();
			return false;
		}
		$eventId = intval($_POST['eventId']);
		$this->model->syncRegList($eventId);
		return true;
	}

	public function register(){
		$sessionId = intval($_POST['sessionId']);
		$contactId = intval($_POST['contactId']);
		$eventType = $this->utility->getArgument(0);

		//154, 1204898
		//http://event-stage.test/registrants/register/?sessionId=116&contactId=1204898
		//http://event-stage.test/registrants/register/live/?sessionId=154&contactId=1204898
		if($_SERVER['REQUEST_METHOD']!=='POST' || !$sessionId || !$contactId){
			View::set404();
			return false;
		}

		$sessions = new model_sessions();
		$session = $sessions->getSession($sessionId);

		if(!$session){
			View::set404();
			return false;
		}
		if(!$eventType || $eventType == 'boot'){
			$this->model->register($contactId,$session);
		}
		if($eventType == 'live'){
			$this->model->registerLive($contactId,$session);
		}
		return true;
	}

	public function confirm(){
		$sessionId = intval($_POST['sessionId']);
		$contactId = intval($_POST['contactId']);
		//http://event-stage.test/registrants/confirm/?sessionId=147&contactId=1204898
		if($_SERVER['REQUEST_METHOD']!=='POST' || !$sessionId || !$contactId){
			View::set404();
			return false;
		}

		$sessions = new model_sessions();
		$session = $sessions->getSession($sessionId);

		if(!$session || !$contactId){
			View::set404();
			return false;
		}

		$this->model->confirm($contactId,$session);

		return true;

	}

	public function removeRegisteredLive(){
		$sessionId = intval($_POST['sessionId']);
		$contactId = intval($_POST['contactId']);
		//http://event-stage.test/registrants/removeRegisteredLive/?sessionId=154&contactId=1204898
		if($_SERVER['REQUEST_METHOD']!=='POST' || !$sessionId || !$contactId){
			View::set404();
			return false;
		}

		$sessions = new model_sessions();
		$session = $sessions->getSession($sessionId);

		if(!$session || !$contactId){
			View::set404();
			return false;
		}

		$this->model->removeRegisteredLive($contactId,$session);

		return true;


	}

	public function vip(){
		$sessionId = intval($_POST['sessionId']);
		$contactId = intval($_POST['contactId']);
		//http://event-stage.test/registrants/vip/?sessionId=146&contactId=1204898
		if($_SERVER['REQUEST_METHOD']!=='POST' || !$sessionId || !$contactId){
			View::set404();
			return false;
		}

		$sessions = new model_sessions();
		$session = $sessions->getSession($sessionId);

		if(!$session || !$contactId){
			View::set404();
			return false;
		}

		$this->model->vip($contactId,$session);

		return true;

	}

	public function cancel(){
		$sessionId = intval($_POST['sessionId']);
		$contactId = intval($_POST['contactId']);
		//http://event-stage.test/registrants/cancel/?sessionId=116&contactId=1204898
		if($_SERVER['REQUEST_METHOD']!=='POST' || !$sessionId || !$contactId){
			View::set404();
			return false;
		}

		$sessions = new model_sessions();
		$session = $sessions->getSession($sessionId);

		if(!$session || !$contactId){
			View::set404();
			return false;
		}

		$this->model->cancel($contactId,$session);

		return true;

	}

	public function phoneSale(){
		$sessionId = intval($_POST['sessionId']);
		$contactId = intval($_POST['contactId']);
		//http://event-stage.test/registrants/cancel/?sessionId=116&contactId=1204898
		if($_SERVER['REQUEST_METHOD']!=='POST' || !$sessionId || !$contactId){
			View::set404();
			return false;
		}

		$sessions = new model_sessions();
		$session = $sessions->getSession($sessionId);

		if(!$session || !$contactId){
			View::set404();
			return false;
		}

		$this->model->phoneSale($contactId,$session);

		return true;

	}

	public function createBootcampContact(){
		if (!$this->model->ajax->checkAjax()){
			View::set404();
			return false;
		}
		$tagId = $_POST['tags'];
		$this->model->createBootcampContact(false,$tagId);
		return true;
	}

	public function markAttendedBootcamp(){
		if (!$this->model->ajax->checkAjax()){
			View::set404();
			return false;
		}
		$contactId = intval($_POST['contactId']);
		$tagId = $_POST['tagId'];
		$this->model->createBootcampContact($contactId,$tagId);
		return true;
	}



	public function markAttended(){
		if (!$this->model->ajax->checkAjax()){
			View::set404();
			return false;
		}
		$this->model->markAttended();
		return true;
	}

	public function markBuyer(){
		if (!$this->model->ajax->checkAjax()){
			View::set404();
			return false;
		}
		$this->model->markBuyer();
		return true;
	}

	public function markAttendedLive(){
		if (!$this->model->ajax->checkAjax()){
			View::set404();
			return false;
		}
		$this->model->markAttendedLive();
		return true;
	}

	public function createLiveContact(){
		if (!$this->model->ajax->checkAjax()){
			View::set404();
			return false;
		}
		$this->model->createLiveContact();
		return true;
	}

	public function processSale(){
		if (!$this->model->ajax->checkAjax()){
			View::set404();
			return false;
		}
		$this->model->processSale();
		return true;
	}

	public function updateEventInfo(){
		if (!$this->model->ajax->checkAjax()){
			View::set404();
			return false;
		}
		$this->model->updateEventInfo();
		return true;
	}

	public function reglog(){
		$this->model->regLog();
		return true;
	}

}