<?php
Class sessions extends Controller{

    public $ajax = false;

    public function __construct() {
        parent::__construct();
        $this->ajax = new ajax();
        return true;
    }

    public function index(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        $eventId = intval($this->utility->getArgument(0));
        $this->view->eventId = $eventId;

        if(!$eventId){
            View::set404();
            return false;
        }
        $event = new model_event();
	    $event = $event->getEvents($eventId);
        if(empty($event)){
            View::set404();
            return false;
        }
	    $this->view->eventType =$event[$eventId]->type;
	    $data = $this->model->getSessions($eventId);
        $this->view->setLayout('admin');
        $this->view->title = 'Session Settings';
        $this->view->sessionList();
        $this->view->render('sessions-list',$data);
        return true;
    }

    public function create(){

        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        if(!$this->model->ajax->checkAjax()){

	        $eventId = intval($this->utility->getArgument(0));
            $this->view->eventId = $eventId;
            if(!$eventId){
                View::set404();
                return false;
            }
            $event = new model_event();
	        $event = $event->getEvents($eventId);
            if(empty($event)){
                View::set404();
                return false;
            }
            $tag = new model_tag();
            $this->view->tags = $tag->getTags(false);
            $this->view->event = $event[$eventId];
            unset($event);
            $data = $this->model->getSessions($eventId);
            $this->view->setLayout('admin');
            $this->view->title = 'Create a new session';
            $this->view->render('session-create',$data);
            return true;
        }else{
            $this->model->createSession();
            return true;
        }
    }

    public function update(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        if(!$this->model->ajax->checkAjax()){
            $this->view->id = $this->utility->getArgument(0);
            $data = $this->model->getSession($this->view->id);
            if(!$data){
                View::set404();
                return false;
            }


            $event = new event();
            $this->view->event = $event->model->getEvents($data->eventId)[$data->eventId];
	        unset($event);

            $this->view->session = $data;
            $data = $this->model->getSessions($this->view->session->eventId);
            $tag = new model_tag();
            $this->view->tags = $tag->getTags(false);
            $this->view->setLayout('admin');
            $this->view->title = 'Update session';
            $this->view->render('session-update',$data);
            return true;
        }else{
            $this->model->updateSession();
            return true;
        }
    }

    public function remove(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        if (!$this->ajax->model->checkAjax()){
            View::set404();
            return false;
        }
        $this->model->removeSession();
        return true;
    }

}