<?php
Class stats extends Controller {

	public function __construct(){
		parent::__construct();
	}

	public function index(){
		View::set404();
		return false;
	}

	public function show(){
		$user = Current::getCurrent()->getUser();
		$isAllowed = $this->utility->checkUserPermissions($user,'10');
		$eventId = intval($this->utility->getArgument(0));
		$event = new event();
		$currentEvent = $event->model->getEvents($eventId)[$eventId];
		if(!$currentEvent || !$isAllowed){
			View::set404();
			return false;
		}

		$this->view->utility = $this->utility;
		$this->view->checkStats = $this->model->haveData($currentEvent);
		$this->view->eventId = $currentEvent->id;
		$data=[];
		if($this->view->checkStats){
			$data = $this->model->show($currentEvent);
		}
		$this->view->setLayout('admin');
		$this->view->title = $currentEvent->title.' Stats';

		$this->view->purchasedTag = $currentEvent->purchasedTag;
		$this->view->attendedTag = $currentEvent->attendedTag;

		if($currentEvent->type == 'boot'){
			$tpl = 'stats-boot';
		}else{
			$tpl = 'stats-live';
		}
		$this->view->render($tpl,$data);
	}

	public function sync(){
		if (!$this->model->ajax->checkAjax()){
			View::set404();
			return false;
		}
		$eventId = intval($_POST['eventId']);
		$event = new event();
		$currentEvent = $event->model->getEvents($eventId)[$eventId];
		if(!$currentEvent){
			View::set404();
			return false;
		}
		unset($event);
		$this->model->sync($currentEvent);
	}



}