<?php
Class tracker extends Controller{

    public $ajax = false;

    public function __construct() {
        parent::__construct();
        $this->ajax = new ajax();
        return true;
    }

    public function index(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        $data = $this->model->getPairs();
        $this->view->setLayout('admin');
        $this->view->index();
        $this->view->title = 'Bootcamp Leadsource Pairs';
        $this->view->render('tracker-list',$data);
        return true;
    }

    public function create(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        $this->view->setLayout('admin');
        $this->view->create();
        $this->view->title = 'Create a new bootcamp tracking pair';
        $this->view->render('tracker-create');
        return true;
    }

    public function createAjax(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        if (!$this->model->ajax->checkAjax()){
            View::set404();
            return false;
        }
        $this->model->create();
        return true;
    }

    public function update(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        $this->view->id = intval($this->utility->getArgument(0));
        $this->view->pair = $this->model->getPairs($this->view->id)[0];
        if(!$this->view->id || !$this->view->pair){
            View::set404();
            return false;
        }
        $this->view->setLayout('admin');
        $this->view->update();
        $this->view->title = 'Update bootcamp tracking pair';
        $this->view->render('tracker-update');
        return true;
    }

    public function updateAjax(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        if (!$this->model->ajax->checkAjax()){
            View::set404();
            return false;
        }
        $this->model->update();
        return true;
    }

    public function remove(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }
        if (!$this->model->ajax->checkAjax()){
            View::set404();
            return false;
        }
        $this->model->remove();
        return true;
    }

    public function processor(){
        $this->model->processor();
        return true;
    }

}