<?php
Class user extends Controller{
    /*
     * permissions:
     * 1 - user
     * 10 - admin
     * 20 - event manager
     * 30 - bootcamp manager
     * 40 - summit manager
     * 50 - Live Boardroom Manager
     */

    public static $userPermissions = array(
        //1 => 'User',
        10 => 'Admin',
        20 => 'Event Manager',
        30 => 'Bootcamp Manager',
        40 => 'Summit Manager',
        50 => 'Live Boardroom Manager'
    );

    public function __construct(){
        parent::__construct();
        return true;
    }

    public function index(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }else{
            $data = $this->model->getUsers();
            $this->view->pageCurrent = $this->model->getCurrentPage();
            $this->view->pageMax = $this->model->getPages();
            $this->view->setLayout('admin');
            $this->view->userList();
            $this->view->render('user-list',$data);
            return true;
        }
    }

    public function edit(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }

        $idString = $this->utility->getArgument(0);
        $id = intval($idString);
        if($idString == ''){
            View::redirectToHome();
            return false;
        }
        $data = $this->model->getUser($id);
        if(empty($data)){
            View::set404();
            return false;
        }
        $this->view->title = 'Edit User';
        $this->view->userUpdate();
        $this->view->setLayout('admin');
        $this->view->render('edit-user',$data);
        return true;
    }

    public function create(){
        $user = Current::getCurrent()->getUser();
        $isAllowed = $this->utility->checkUserPermissions($user,'10');
        if(!$isAllowed){
            View::set404();
            return false;
        }

        $this->view->title = 'Create a new user';
        $this->view->setLayout('admin');
        $data['userPermissions'] = self::getPermissions();
        $this->view->userCreate();
        $this->view->render('create-user');
        return true;
    }

    public static function getPermissions(){
        return self::$userPermissions;
    }

    public function login(){
        if (!$this->model->ajax->checkAjax()){
            View::set404();
            return false;
        }
        $this->model->login();
        return true;
    }

    public function userUpdate(){
        if (!$this->model->ajax->checkAjax()){
            View::set404();
            return false;
        }
        $id = $_POST['userID'];
        $this->model->userUpdate($id);
        return true;
    }

    public function userCreate(){
        if (!$this->model->ajax->checkAjax()){
            View::set404();
            return false;
        }
        $this->model->userCreate();
        return true;
    }

    public function userBan(){
        if (!$this->model->ajax->checkAjax()){
            View::set404();
            return false;
        }
        $id = intval($_POST['userID']);
        $unBan = false;
        if($_POST['unBan']){
            $unBan = true;
        }
        $this->model->userBan($id,$unBan);
        return true;
    }

    public function userRemove(){
        if (!$this->model->ajax->checkAjax()){
            View::set404();
            return false;
        }
        $id = intval($_POST['userID']);
        $this->model->userRemove($id);
        return true;
    }

}