<?php

class model_ajax extends Model{

    protected $state;
    protected $error;
    protected $response;
    protected $errorCode = array(
        1 => "URL doesn't exist",
        5 => 'Can\'t log in',
        6 => 'User already exists',
        7 => 'Email was not found',
        8 => 'You forgot to specify tag id',
        9 => 'Infusionsoft error',
        10 => 'Tag already applied',
        11 => 'Contacts not found',
        12 => 'Error occurred',
        13 => 'Infusionsoft responded with empty array',
        14 => 'Note wasn\'t added, please, try again later',
        15 => 'Fields can not be empty',
	    16 => 'Event with this ID was no found',
	    17 => 'Tag settings are not configured for this event',
	    18 => 'Tag base is empty'
    );
    public function __construct(){
        parent::__construct();
        $this->response = new stdClass();
        $this->db = Database::getDatabase();
        $this->fields = ['addNewTag','regTag','addNewTagSummit','regTagSummit'];
        return true;
    }

    public function checkAjax(){
        if ($_SERVER["REQUEST_METHOD"]!="POST"){
            return false;
        }else{
            return true;
        }
    }

    public function setResponse($state,$stateCode = false){
        if ($state){
            $this->response->id = $stateCode;
        }else{
            $this->response->error = $this->errorCode[$stateCode];
            $this->log->logError('Error Occured - '.$this->response->error);
        }
    }

    /*
     * @return id - int - id of database inserted index
     * @return error
     */
    public function getResponse(){
        echo json_encode($this->response);
    }

    public function getContactsByTag($tagId){
        if(!$tagId){
            $this->setResponse(false,8);
            $this->getResponse();
            return false;
        }
        $isoft = new Infusionsoft();
        $contacts = $isoft->getContactsByTag($tagId);
        return $contacts;
    }

    public function markAttended($contactId,$tableName){
        $this->log->add("Mark Attended Called - ContactId:".$contactId);
        if(!$tableName){
            $this->setResponse(false,12);
            $this->getResponse();
            return false;
        }
        $data = ['attended' => 'Y'];
        $id = $this->db->updateRecord($tableName, $data, [ 'ContactId'=>$contactId ] );
        if($id){
            $this->setResponse(true,$id);
            $this->getResponse();
            return true;
        }else{
            $this->setResponse(false,12);
            $this->getResponse();
            return false;
        }
    }

    public function submitNote(){
        $tagId = intval(urldecode($_POST['tagId']));
        $contactId = intval(urldecode($_POST['contactId']));
        $note = $_POST['note'];
        $this->log->add("Submit Note Called - ContactId:".$contactId);
        if(!$contactId || !$note){
            $this->setResponse(false,12);
            $this->getResponse();
            return false;
        }
        $isoft = new Infusionsoft();
        $addToNote = date('n/j/Y').' (3rd party) ';
        $noteResult = $isoft->addNote($contactId,$addToNote.$note);
        if(!$noteResult){
            $this->setResponse(false,14);
            $this->getResponse();
            return false;
        }
        if($tagId){
            $isoft->applyTagById($contactId,$tagId);
        }
        $this->setResponse(true,1);
        $this->getResponse();
        return true;
    }
}