<?php
/**
 * Created by PhpStorm.
 * User: alex
 * Date: 10/2/18
 * Time: 17:39
 */

class model_infusion extends Model {
	public function __construct(){
		parent::__construct();
		$this->fields = [
			//boot
			'addNewTag'
		];
		return true;
	}

	public function createPostEmail(){
		$id = intval($_POST['contact_id']);
		$post = [
			'contact_id' => $id,
			'contact_email' => $_POST['contact_email'],
			'contact_name'   => $_POST['contact_name'],
		];
		return $post;
	}

	public function callZapier($zapierLink, $post){
		$ch = curl_init($zapierLink);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
		$response = curl_exec($ch);
		curl_close($ch);

		return $response;
	}

	public function bootRegister($contactId = false, $tags=[]){
		$email = $_POST['contact_email'];
		$firstName = $_POST['contact_name'];
		$sessionId = intval($_POST['session_id']);
		$phone = $_POST['contact_phone'];
		$source = $_POST['utm_source'] ? $_POST['utm_source'] :'';
		$term = $_POST['utm_term'] ? $_POST['utm_term'] :'';

		if(!$contactId){

			if(!$email){
				return false;
			}

			if(!$sessionId){
				return false;
			}
			$fields = [
				'Phone1' => $phone,
				'Email' => $email,
				'FirstName' => $firstName,
				'_VenueFile' => $sessionId,
			];



		}else{
			$fields = [
				'Phone1' => $phone,
				'_VenueFile' => $sessionId,
			];
		}


		if($source){
			$fields['_GaSource'] = $source;
		}

		if($term){
			$fields['_GaTerm'] = $term;
		}


		$data = $this->getStateData();
		$ifs = new Infusionsoft();
		if(!$contactId){
			$cId = $ifs->createUpdateContact($email,$fields);
		}else{
			$cId = $ifs->updateContact($contactId,$fields);
		}
		$ifs->applyTagById($cId, 11710 );

		if(!empty($tags)){
			foreach($tags as $tag){
				$ifs->applyTagById($cId, intval($tag) );
			}
		}

		$result = ['session' => $sessionId,
			'contactId' => $cId];
		return $result;
	}

	public function step1($tags=[]){
		$email = $_POST['contact_email'];
		$firstName = $_POST['contact_name'];
		$source = $_POST['utm_source'] ? $_POST['utm_source'] :'';
		$term = $_POST['utm_term'] ? $_POST['utm_term'] :'';
		if(!$email){
			return false;
		}
		if(!$firstName){
			return false;
		}
		$fields = [
			'Email' => $email,
			'FirstName' => $firstName,
			'_GaSource' => $source,
			'_GaTerm' => $term
		];

		$cleanFields = [];
		foreach($fields as $k=>$v){
			if($v){
				$cleanFields[$k]=$v;
			}
		}
		$fields = $cleanFields;
		unset($cleanFields);

		$ifs = new Infusionsoft();
		$cId = $ifs->createUpdateContact($email,$fields);
		if(!empty($tags)){
			foreach($tags as $tag){
				$ifs->applyTagById($cId, intval($tag) );
			}
		}
		return $cId;
	}


	public function step2($contactId,$tags=[]){
		$phone = $_POST['contact_phone'];
		$source = $_POST['utm_source'] ? $_POST['utm_source'] :'';
		$term = $_POST['utm_term'] ? $_POST['utm_term'] :'';
		$fields = [
			'Phone1' => $phone,
			'_GaSource' => $source,
			'_GaTerm' => $term
		];
		return $this->updateContact($fields,$contactId,$tags);
	}


	public function step3($contactId,$tags=[]){
		$sessionId = intval($_POST['session_id']);
		if(!$sessionId){
			return false;
		}
		$fields = [
			'_VenueFile' => $sessionId
		];
		$this->updateContact($fields,$contactId,$tags);
		$result = ['session' => $sessionId,
			'contactId' => $contactId];
		return $result;
	}

	public function updateContact($fields,$contactId, $tags = []){
		$cleanFields = [];
		foreach($fields as $k=>$v){
			if($v){
				$cleanFields[$k]=$v;
			}
		}
		unset($fields);
		$ifs = new Infusionsoft();
		$ifs->updateContact($contactId,$cleanFields);
		if(!empty($tags)){
			foreach($tags as $tag){
				$ifs->applyTagById($contactId, intval($tag) );
			}
		}
		return $contactId;
	}



}