<?php
Class model_leadsource extends Model{
    public $ajax;
    public $catId = [25,6,28,4,34,36,8];
    public $backupLeadsource = 43746;

    public function __construct(){
        parent::__construct();
        $this->ajax = new model_ajax();
        return true;
    }

    public function getLeadsources($id=false){
        if(!$id) {
            $sql = 'SELECT * FROM `leadsources`;';
        }else{
            $sql = 'SELECT * FROM `leadsources` WHERE id='.$id.';';
        }
        $data = $this->db->hardSelect($sql);


        if(!empty($data)){
            $newData = [];
            foreach($data as $leadSource){
                $newData[$leadSource->id] = $leadSource->Name;
            }
        }else{
            $newData = $data;
        }

        return $newData;
    }

    public function getPairs($id=false){
        if(!$id){
            $sql = 'SELECT leadsourcePairs.LeadSourceId as LeadSourceId, leadsourcePairs.SourceVal as SourceVal, leadsourcePairs.id as id, leadsources.Name as Name FROM `leadsourcePairs` JOIN `leadsources` ON leadsourcePairs.LeadSourceId=leadsources.id;';
        }else{
            $sql = 'SELECT leadsourcePairs.LeadSourceId as LeadSourceId, leadsourcePairs.SourceVal as SourceVal, leadsourcePairs.id as id, leadsources.Name as Name FROM `leadsourcePairs` JOIN `leadsources` ON leadsourcePairs.LeadSourceId=leadsources.id WHERE leadsourcePairs.id='.$id.';';
        }
        return $this->db->hardSelect($sql);
    }

    public function create(){
        $leadSourceId = intval($_POST['leadSourceId']);
        $SourceVal = $_POST['SourceVal'];
        if(!$leadSourceId || !$SourceVal){
            $this->ajax->setResponse(false,15);
            $this->ajax->getResponse();
            return false;
        }
        $databaseValues = ['SourceVal'=>$SourceVal,'LeadSourceId'=>$leadSourceId];
        $id = $this->db->insert('leadsourcePairs',$databaseValues);
        $this->ajax->setResponse(true,$id);
        $this->ajax->getResponse();
        return true;
    }

    public function update(){
        $leadSourceId = intval($_POST['leadSourceId']);
        $SourceVal = $_POST['SourceVal'];
        $id = intval($_POST['id']);
        if(!$leadSourceId || !$SourceVal ||!$id){
            $this->ajax->setResponse(false,15);
            $this->ajax->getResponse();
            return false;
        }
        $databaseValues = ['SourceVal'=>$SourceVal,'LeadSourceId'=>$leadSourceId];
        $id = $this->db->updateRecord('leadsourcePairs', $databaseValues, array('id'=>$id));
        $this->ajax->setResponse(true,$id);
        $this->ajax->getResponse();
        return true;
    }

    public function remove(){
        $id = intval($_POST['id']);
        if(!$id){
            $this->ajax->setResponse(false,12);
            $this->ajax->getResponse();
            return false;
        }
        $this->db->hardDelete('DELETE FROM `leadsourcePairs` WHERE id='.$id.';');
        $this->ajax->setResponse(true,$id);
        $this->ajax->getResponse();
        return true;
    }

    public function sync(){
        $ifs = new Infusionsoft();
        $leadsources = $ifs->getLeadsources($this->catId);
        if(empty($leadsources) || !$leadsources){
            $this->ajax->setResponse(false,13);
            $this->ajax->getResponse();
            return false;
        }
        $this->db->hardDelete('DELETE FROM `leadsources`;');
        $values = '';

        foreach($leadsources as $record){
            $values .= ",(".$record['Id'].",'".addslashes($record['Name'])."')";
        }
        $values = substr($values,1);
        $this->db->simpleQuery('INSERT INTO `leadsources` (id, Name) VALUES '.$values.';');
        $this->ajax->setResponse(true,200);
        $this->ajax->getResponse();
        return true;
    }

    public function processor(){
        //http://event-stage.test/leadsource/processor/?contactId=1204898&sourceVal=GA_PDX_June_2018
        $contactId = intval($_POST['contactId']);
        $sourceVal = strtolower($_POST['sourceVal']);
        if (!$contactId){
            return false;
        }
        $pairs = $this->getPairs(false);
        if(empty($pairs)){
            return false;
        }
        $result = false;
        $ifs = new Infusionsoft();
        foreach($pairs as $pair){
            $dbVal = strtolower($pair->SourceVal);
            if ($dbVal == $sourceVal){
                $result = $ifs->updateLeadsource($contactId,$pair->LeadSourceId);
            }
        }
        if(!$result){
            $result = $ifs->updateLeadsource($contactId,$this->backupLeadsource);
        }
        return $result;
    }

}