<?php
Class model_sessions extends Model{
    public $ajax;

    public function __construct(){
        parent::__construct();
        $this->ajax = new model_ajax();
        return true;
    }

    public function getSessions($eventId){
        $sql = 'SELECT * FROM sessions WHERE eventId='.$eventId.' ORDER BY startStamp ASC';
        $data = $this->db->hardSelect($sql);

        if(!empty($data)){
            $newData = array();
            foreach($data as $session){
                $newData[$session->id] = $session;
            }
        }else{
            $newData = $data;
        }
        return $newData;
    }

    public function getTimeStampFromSession($string){
	    if($string!='TBA'){
	    	$dateOnly = explode(' ',$string)[0];
		    $parts = explode('-',$dateOnly);
		    $year = intval($parts[0]);
		    $month = intval($parts[1]);
		    $day = intval($parts[2]);
		    $time = mktime(0,0,0,$month,$day,$year);
	    }else{
	    	$time = 0;
	    }
	    return $time;
    }

    public function createSession(){

		$stamp = $this->getTimeStampFromSession($_POST['sessionChosen']);
        $data = array(
            'hotelName'=>$_POST['hotelName'],
            'street'=>$_POST['street'],
            'hotelPhone'=>$_POST['hotelPhone'],
            'fullDate'=>$_POST['fullDate'],
            'sessionChosen'=>$_POST['sessionChosen'],
            'tags'=>$_POST['tags'],
            'eventId'=>$_POST['eventId'],
	        'startStamp' => $stamp
        );

	    $data = $this->addTypeSpecificField('surveyForm',$_POST['surveyForm'],intval($_POST['eventId']),'boot',$data);
	    $data = $this->addTypeSpecificField('hours',$_POST['hours'],intval($_POST['eventId']),'live',$data);

        $id = $this->db->insert('sessions', $data);
        $this->ajax->setResponse(true,$id);
        $this->ajax->getResponse();
        return true;
    }

    public function updateSession(){
	    $stamp = $this->getTimeStampFromSession($_POST['sessionChosen']);
        $data = array(
            'hotelName'=>$_POST['hotelName'],
            'street'=>$_POST['street'],
            'hotelPhone'=>$_POST['hotelPhone'],
            'fullDate'=>$_POST['fullDate'],
            'sessionChosen'=>$_POST['sessionChosen'],
            'tags'=>$_POST['tags'],
	        'startStamp' => $stamp
        );

	    $data = $this->addTypeSpecificField('surveyForm',$_POST['surveyForm'],intval($_POST['eventId']),'boot',$data);
	    $data = $this->addTypeSpecificField('hours',$_POST['hours'],intval($_POST['eventId']),'live',$data);
        $id = $this->db->updateRecord('sessions', $data, array('id'=>intval($_POST['id'])));
        $this->ajax->setResponse(true,$id);
        $this->ajax->getResponse();
        return true;
    }

    public function addTypeSpecificField($fieldName,$fieldValue,$eventId,$eventType,$array){
	    $event = new event();
	    $currentEvent = $event->model->getEvents($eventId)[$eventId];

	    if($currentEvent->type == $eventType){
		    $array[$fieldName] = $fieldValue;
	    }

	    return $array;
    }

    public function removeSession(){
        $id = intval($_POST['id']);
        if(!$id){
            $this->ajax->setResponse(false,5);
            $this->ajax->getResponse();
            return false;
        }
        $this->db->hardDelete('DELETE FROM `sessions` WHERE id='.$id.';');
        $this->ajax->setResponse(true,1);
        $this->ajax->getResponse();
        return true;
    }

    public function getSession($id){
        $sql = 'SELECT * FROM sessions WHERE id='.$id;
        $data = $this->db->hardSelect($sql);
        return $data[0]?$data[0]:false;
    }


}