<?php
Class model_stats extends Model{

	public $ajax;

	public function __construct(){
		parent::__construct();
		$this->ajax = new model_ajax();
		return true;
	}

	public function show($currentEvent){
	$data = [];

	if($currentEvent->type == 'boot'){
		$data = $this->statsBootcamp($currentEvent);
	}

	if($currentEvent->type == 'live'){
		$data = $this->statsLive($currentEvent);
	}

		return $data;
	}

	public function haveData($currentEvent){
		$query = 'SELECT * FROM `stats` WHERE eventId='.$currentEvent->id.' LIMIT 0,1';
		$data = $this->db->hardSelect($query);
		if(!empty($data) && $data){
			return true;
		}else{
			return false;
		}
	}

	public function statsLive($currentEvent){
		$data = [];
		$data['totalSessions'] = $this->getEventData($currentEvent->id);
		$data['totalLeadsource'] = $this->getLeadsourcesTotal($currentEvent->id);
		return $data;
	}

	public function statsBootcamp($currentEvent){


		$data = [];
		$sessions = $this->getSessionsList($currentEvent->type,$currentEvent->id);

		//grouped by sessions, current event id, current sessions only
		$data['numbersBySessionId'] = $this->getSessionData($sessions,$currentEvent->id);
		$data['numbersBySessionId'] = $this->fillOutEmptySessions($sessions,$data['numbersBySessionId']);
		$data['sessionNames'] = $this->getSessionNames($currentEvent->id);

		//filtered out contacts
		//$data['filteredOutContacts'] = $this->getContactsFilteredOut($sessions,$currentEvent->id);

		//filtered out stats
		$data['filteredOutStats'][0] = $this->countTotal($this->getFilteredOutStats($sessions,$currentEvent->id));
		$data['filteredOutStats'][0]->sessionId = 'session undefined';

		//*************** Grouped session stats for output ***************
		$data['totalSessions'] = $this->mergeFiltered($data['numbersBySessionId'],$data['filteredOutStats']);
		$data['totalSessions'] = $this->sortStats($data['totalSessions'],$sessions);

		//*************** Total stats for output ***************
		$data['total'] = $this->countTotal($data['totalSessions']);

		unset($data['filteredOutStats']);
		unset($data['numbersBySessionId']);


		//*************** Leadsource stats for output ***************
		$data['totalLeadsource'] = $this->getLeadsourcesTotal($currentEvent->id);
		$leadsourceList = $this->getLeadsourceList($data['totalLeadsource']);
		$data['leadsourceStats'] = $this->sessionByLeadsource($sessions,$leadsourceList,$currentEvent->id);
		//echo '<pre>';
		//var_dump($data['totalLeadsource']);
//		var_dump($sessions);
		//exit;
		return $data;
	}

	public function sessionByLeadsource($sessionList,$leadsourceList,$eventId){
		$data = [];
		foreach($sessionList as $session){
			foreach($leadsourceList as $leadsource){
				$sql = 'SELECT SUM(registered) as regSum, SUM(attended) as atSum, SUM(confirmed) as confSum, SUM(purchased) as purSum FROM `stats` WHERE sessionId='.$session.' AND eventId='.$eventId.' AND leadsource="'.$leadsource.'" GROUP BY leadsource';
				$result = $this->db->hardSelect($sql);
				if(empty($result)){
					$empty = new stdClass();
					$empty->regSum = 0;
					$empty->atSum = 0;
					$empty->confSum = 0;
					$empty->purSum = 0;
					$data[$session][$leadsource] = $empty;
				}else{
					$data[$session][$leadsource] = $result[0];
				}

			}
		}
		return $data;
	}

	public function getLeadsourceList($leadsourceTotal){
		$leadsources = [];
		foreach($leadsourceTotal as $row){
			$leadsources[] = $row->leadsource;
		}
		return $leadsources;
	}

	public function getLeadsourcesTotal($eventId){
		$sql = 'SELECT SUM(registered) as regSum, SUM(attended) as atSum, SUM(confirmed) as confSum, SUM(purchased) as purSum, leadsource FROM `stats` WHERE eventId='.$eventId.' GROUP BY leadsource ORDER BY regSum DESC';
		return $this->db->hardSelect($sql);
	}

	public function mergeFiltered($data,$filteredData){
		if($filteredData[0]->regSum != 0){
			return array_merge($data,$filteredData);
		}else{
			return $data;
		}

	}

	public function getSessionNames($eventId){
		$session = new sessions();
		$sessions = $session->model->getSessions($eventId);
		$data = [];
		if($sessions && !empty($sessions)){
			foreach($sessions as $row){
				$parts = explode('at', $row->fullDate);
				$last = array_pop($parts);
				$parts = array(implode('at', $parts), $last);
				$data[$row->id]=trim($parts[0]);
			}
		}
		return $data;
	}

	public function sortStats($stats,$sessionList){
		$sorted = [];
		foreach($sessionList as $sessionId){
			foreach($stats as $k=>$stat){
				if(intval($stat->sessionId) == $sessionId){
					$sorted[] = $stat;
					unset($stats[$k]);
				}
			}
		}
		return array_merge($sorted,$stats);
	}

	public function fillOutEmptySessions($sessionList,$data){
		foreach($data as $row){

			$key = array_search(intval($row->sessionId),$sessionList);

			if($key!==false){
				unset($sessionList[$key]);
			}
		}
		$i = count($data);
		if(!empty($sessionList)){
			foreach($sessionList as $session){
				$data[$i] = new stdClass();
				$data[$i]->regSum = 0;
				$data[$i]->atSum = 0;
				$data[$i]->purSum = 0;
				$data[$i]->confSum = 0;
				$data[$i]->sessionId = $session;
				$i++;
			}
		}
		return $data;
	}

	public function getContactsFilteredOut($sessionList, $eventId){
		$inStatement = $this->getInStatement($sessionList);
		$query = $query = 'SELECT contactId FROM `stats` WHERE eventId='.$eventId.' AND sessionId NOT IN ('.$inStatement.')';
		return $this->db->hardSelect($query);
	}

	public function getFilteredOutStats($sessionList,$eventId){
		$inStatement = $this->getInStatement($sessionList);
		$query = $query = 'SELECT SUM(registered) as regSum, SUM(attended) as atSum, SUM(confirmed) as confSum, SUM(purchased) as purSum, sessionId FROM `stats` WHERE eventId='.$eventId.' AND sessionId NOT IN ('.$inStatement.') GROUP BY sessionId';
		return $this->db->hardSelect($query);
	}

	public function countTotal($data){
		$total = new stdClass();
		$total->regSum = 0;
		$total->atSum = 0;
		$total->confSum = 0;
		$total->purSum = 0;

		foreach($data as $stat){
			$total->regSum += intval($stat->regSum);
			$total->atSum += intval($stat->atSum);
			$total->confSum += intval($stat->confSum);
			$total->purSum += intval($stat->purSum);
		}

		return $total;
	}

	public function getSessionData($sessionList, $eventId){
		$inStatement = $this->getInStatement($sessionList);
		$query = 'SELECT SUM(registered) as regSum, SUM(attended) as atSum, SUM(confirmed) as confSum, SUM(purchased) as purSum, sessionId FROM `stats` WHERE sessionId IN ('.$inStatement.') AND eventId='.$eventId.' GROUP BY sessionId';
		return $this->db->hardSelect($query);
	}

	public function getEventData($eventId){
		$query = 'SELECT SUM(registered) as regSum, SUM(attended) as atSum, SUM(confirmed) as confSum, SUM(purchased) as purSum FROM `stats` WHERE eventId='.$eventId.' GROUP BY eventId';
		return $this->db->hardSelect($query);
	}

	public function getInStatement($arrayIds){
		$inStatement = '';
		foreach($arrayIds as $id){
			$inStatement.= $id.',';
		}
		return rtrim($inStatement,',');
	}

	public function sync($currentEvent){
		$tags = [
			'regTag'=>$currentEvent->tagId,
			'attendedTag'=>$currentEvent->attendedTag,
			'confirmedTag'=>$currentEvent->confirmedTag,
			'purchasedTag'=>$currentEvent->purchasedTag,
		];

		$sessionList = $this->getSessionsList($currentEvent->type,$currentEvent->id);
		if(!$sessionList){
			$this->ajax->setResponse(false,12);
			$this->ajax->getResponse();
			return false;
		}

		$fields = $this->getIFSfields($currentEvent->type);
		$contacts = $this->getIFSContacts($tags,$fields);
		if(empty($contacts) || !$contacts){
			$this->ajax->setResponse(false,13);
			$this->ajax->getResponse();
			return false;
		}

		$normalizedContacts = $this->normalizeContacts($contacts,$currentEvent->type,$sessionList);
		$this->addToTable($normalizedContacts,$currentEvent->id);
		return true;
	}

	public function getIFSfields($type){
		$fields = ['_BootcampSource','Id'];
		if($type == 'boot'){
			array_push($fields,'_VenueFile');
		}
		if($type == 'live'){
			array_push($fields,'_LiveEventSessionId');
		}
		return $fields;
	}

	public function getSessionsList($type, $eventId){
		$sessionList = [];
		$session = new sessions();
		if($type == 'boot'){
			$currentSessions = $session->model->getSessions($eventId);
			if(empty($currentSessions) || !$currentSessions){
				return false;
			}
			foreach($currentSessions as $currentSession){
				$sessionList[] = intval($currentSession->id);
			}
		}else{
			$currentSessions = $session->model->getSessions($eventId);
			if(empty($currentSessions) || !$currentSessions){
				$sessionList[] = 0;
			}else{
				foreach($currentSessions as $currentSession){
					$sessionList[] = intval($currentSession->id);
				}
			}
		}
		return $sessionList;
	}

	public function getIFSContacts($tags,$fields){
		$ifs = new Infusionsoft();
		$contacts = [];
		foreach($tags as $name => $tag){
			$ifsContacts = $ifs->getContactsByTag($tag,true,$fields);
			$contacts[$name] = empty($ifsContacts)||!$ifsContacts ? [] : $ifsContacts;
		}
		return $contacts;
	}

	public function normalizeContacts($contacts,$type = 'boot',$sessionList){
		$sorted = [];
		foreach($contacts['regTag'] as $contact){
			if($type == 'boot' && !in_array(intval($contact['_VenueFile']),$sessionList)){
				$sorted[$contact['Id']]['reregistered'] = true;
			}else{
				$sorted[$contact['Id']]['reregistered'] = false;
			}
			if($type == 'boot'){
				$sorted[$contact['Id']]['sessionId'] = intval($contact['_VenueFile']);
			}else{
				$sorted[$contact['Id']]['sessionId'] = intval($contact['_LiveEventSessionId']);
			}
			$sorted[$contact['Id']]['Id'] = intval($contact['Id']);
			$sorted[$contact['Id']]['Leadsource'] = $contact['_BootcampSource']?$contact['_BootcampSource']:'[leadsource is empty]';
			$sorted[$contact['Id']]['registered'] = true;
			$sorted[$contact['Id']]['attended'] = false;
			$sorted[$contact['Id']]['confirmed'] = false;
			$sorted[$contact['Id']]['purchased'] = false;
		}

		$sorted = $this->marker($contacts,$sorted,'regTag','registered');
		$sorted = $this->marker($contacts,$sorted,'attendedTag','attended');
		$sorted = $this->marker($contacts,$sorted,'confirmedTag','confirmed');
		$sorted = $this->marker($contacts,$sorted,'purchasedTag','purchased');

		return $sorted;
	}

	public function marker($contacts,$sorted,$tagName, $fieldName){
		if(!empty($contacts[$tagName]) && $contacts[$tagName] ){
			foreach($contacts[$tagName] as $contact){
				if($sorted[$contact['Id']]){
					$sorted[$contact['Id']][$fieldName] = true;
				}
			}
		}
		return $sorted;
	}

	public function addToTable($contacts,$eventId){
		$this->db->hardDelete('DELETE FROM `stats` WHERE eventId='.$eventId.';');
		$values = '';
		foreach($contacts as $record){
			$leadsource = filter_var($record['Leadsource'], FILTER_SANITIZE_STRING);
			$registered = $record['registered']?1:0;
			$confirmed = $record['confirmed']?1:0;
			$attended = $record['attended']?1:0;
			$purchased = $record['purchased']?1:0;
			$reregistered = $record['reregistered']?1:0;
			$values .= ",(".$eventId.",".$record['sessionId'].",'".$leadsource."',".$registered.",".$confirmed.",".$attended.",".$purchased.",".$record['Id'].",".$reregistered.")";
		}
		$values = ltrim($values,',');
		$query = 'INSERT INTO `stats` (eventId, sessionId, leadsource, registered, confirmed, attended , purchased, contactId, reregistered) VALUES '.$values.';';
		$this->db->simpleQuery($query);
		$this->ajax->setResponse(true,1);
		$this->ajax->getResponse();
		return true;

	}

}