<?php

Class model_tag extends Model {
    public $ajax = false;

    public function __construct() {
        parent::__construct();
        $this->ajax = new model_ajax();
        return true;
    }

    public function sync() {
        $this->log->add("Tag Syncing");
        $isoft = new Infusionsoft();
        $tags = $isoft->getAllTags();
        if(empty($tags)){
            $this->ajax->setResponse(false,13);
            $this->ajax->getResponse();
            return false;
        }
        $this->db->hardDelete('DELETE FROM `tags`;');
        $values = '';
        foreach($tags as $record){
            $values .= ",(".$record['Id'].",'".addslashes($record['GroupName'].' (id - '.$record['Id'].')')."')";
        }
        $values = substr($values,1);
        $this->db->simpleQuery('INSERT INTO `tags` (tagId, tagName) VALUES '.$values.';');
        $this->ajax->setResponse(true,200);
        $this->ajax->getResponse();
        return true;
    }

    public function getTagName($id){
    	$id = intval($id);
    	if(!$id){
    		return false;
	    }
    	$sql = 'SELECT * FROM `tags` WHERE tagId='.$id;
	    $row = $this->db->hardSelect($sql);
	    if($row){
	    	return $row[0]->tagName;
	    }else{
	    	return false;
	    }
	}

    public function getTags($object = true){
        $sql = 'SELECT * FROM `tags`';
        if($object){
        return $this->db->hardSelect($sql);
        }else{
            $tags = $this->db->hardSelect($sql);
            if(empty($tags)){
                return [];
            }
            $tagArray = [];

            foreach($tags as $tag){
                $tagArray[$tag->tagId] = $tag->tagName;

            }
            return $tagArray;
        }
    }

    public function applyTag($email,$tagID){
        if(!$email){
            $this->ajax->setResponse(false,7);
            $this->ajax->getResponse();
            return false;
        }
        if(!$tagID){
            $this->ajax->setResponse(false,8);
            $this->ajax->getResponse();
            return false;
        }
        $isoft = new Infusionsoft();
        $contactId = $isoft->findByEmail($email);
        if(!$contactId){
            $this->ajax->setResponse(false,7);
            $this->ajax->getResponse();
            return false;
        }
        $result = $isoft->applyTagById($contactId,$tagID);
        if(!$result){
            $this->ajax->setResponse(false,10);
            $this->ajax->getResponse();
            return false;
        }else{
            $this->ajax->setResponse(true,1);
            $this->ajax->getResponse();
            return true;
        }
    }

    public function applyTagByID($contactId,$tagID){

        $this->log->add('Apply tag by ID called - ContactID:'.$contactId.'; TagId:'.$tagID);

        if(!$contactId){
            $this->ajax->setResponse(false,7);
            $this->ajax->getResponse();
            return false;
        }

        if(!$tagID){
            $this->ajax->setResponse(false,8);
            $this->ajax->getResponse();
            return false;
        }

        $isoft = new Infusionsoft();
        $result = $isoft->applyTagById($contactId,$tagID);

        if  (!$result){
            $this->ajax->setResponse(false,10);
            $this->ajax->getResponse();
            return false;
        }

        $this->ajax->setResponse(true,1);
        $this->ajax->getResponse();
        return true;
    }

    public function eventTags($type='boot'){
    	$tags= [];
    	switch ($type){
		    case 'boot':
			    $tags [] = ['Name' => "~BASE~", 'Cat' => 162];
			    $tags [] = ['Name' => "~BASE~ - Attended", 'Cat' => 162];
			    $tags [] = ['Name' => "~BASE~ - Cancelled", 'Cat' => 162];
			    $tags [] = ['Name' => "~BASE~ - Confirmed", 'Cat' => 162];
			    $tags [] = ['Name' => "~BASE~ - Purchased a Product", 'Cat' => 162];
			    $tags [] = ['Name' => "~BASE~ - Phone Purchase", 'Cat' => 162];
			    break;
		    case 'live':
			    //$tags [] = ['Name' => "10-19 - Promo - ~BASE~", 'Cat' => 168];
			    $tags [] = ['Name' => "WP - RWT Live - ~BASE~", 'Cat' => 26];
			    $tags [] = ['Name' => "Purchased a Product - ~BASE~", 'Cat' => 174];
			    //$tags [] = ['Name' => "Survey Form - ~BASE~", 'Cat' => 174];
			    $tags [] = ['Name' => "Bought Ticket - ~BASE~", 'Cat' => 174];
			    $tags [] = ['Name' => "LIVE Free Ticket - ~BASE~", 'Cat' => 174];
			    //$tags [] = ['Name' => "Regular Refund - ~BASE~", 'Cat' => 174];
			    $tags [] = ['Name' => "Canceled - ~BASE~", 'Cat' => 174];
			    $tags [] = ['Name' => "Live Event Attended - ~BASE~", 'Cat' => 174];
			    //$tags [] = ['Name' => "Survey Form - ~BASE~ (Form)", 'Cat' => 174];
			    $tags [] = ['Name' => "Bought VIP Ticket - ~BASE~", 'Cat' => 174];
			    $tags [] = ['Name' => "Phone Purchase - ~BASE~", 'Cat' => 174];
			    $tags [] = ['Name' => "Confirmed - ~BASE~", 'Cat' => 174];
			    break;
		    case 'lb':
			    $tags [] = ['Name' => "Confirmed - ~BASE~", 'Cat' => 221];
			    $tags [] = ['Name' => "Attended - ~BASE~", 'Cat' => 221];
			    $tags [] = ['Name' => "Can't Go - ~BASE~", 'Cat' => 221];
	    }
	    return $tags;
    }

    public function eventTagsFront($type){
    	$tags = $this->eventTags($type);
    	$tagNames = [];
    	foreach($tags as $tag){
    		$tagNames[] = $tag['Name'];
	    }
	    return $tagNames;
    }

    public function createTags($base, $type){
		if(!$base){
			$this->ajax->setResponse(false,18);
			$this->ajax->getResponse();
			return false;
		}
		$ifs = new Infusionsoft();
		switch ($type){
			case 'boot':
				$tags = $this->eventTags('boot');
				break;
			case 'live':
				$tags = $this->eventTags('live');
				break;
			case 'lb':
				$tags = $this->eventTags('lb');
				break;
			default:
				$tags = $this->eventTags('boot');
		}
		foreach($tags as $tag){
			$tagName = str_replace("~BASE~",$base,$tag['Name']);
			$ifs->createTags($tagName,$tag['Cat']);
		}
	    $this->ajax->setResponse(true,1);
	    $this->ajax->getResponse();
	    return true;
    }


}