<?php
Class model_user extends Model{
    protected $_perPage = 20;
    public $ajax = false;

    public function __construct(){
    parent::__construct();
        $this->ajax = new model_ajax();
        return true;
    }

    public function getUser($id){
        $query = $this->db->getData('users','*')->where('users.userID='.$id.' AND userRemoved = 0');
        //$query->show();
        $data = $query->execute();
        return $data;
    }

    public function getUsers(){
        $begin = $this->utility->getParam('page') == false ? 0 : ($this->utility->getParam('page')*$this->_perPage)-$this->_perPage;
        $data = array();

        $orderString = '';
        $whereStr = '';

        if($_GET['id-order']){
            $orderString .= ', userID '.$_GET['id-order'];
        }
        if ($_GET['banned']){
            $orderString .= ', userBanned '.$_GET['banned'];
        }

        /*
         * Form order string for the query
         */
        $orderString = preg_replace('/^, /i','',$orderString);
        $orderString = $orderString ? ' ORDER BY '.$orderString : ' ORDER BY userID DESC';

        /*
         * Form Where for the query
         */

        $whereStr .= ' AND userRemoved = 0';
        if($_GET['nickname']){
            $whereStr .= ' AND userNickName LIKE "%'.$_GET['nickname'].'%"';
        }
        if($_GET['mail']){
            $whereStr .= ' AND userLogin LIKE "%'.$_GET['mail'].'%"';
        }
        $whereStr = preg_replace('/^ AND/i',' WHERE',$whereStr);

        $sql = 'SELECT * FROM users'.$whereStr.$orderString.' LIMIT '.$begin.', '.$this->_perPage;
        $data = $this->db->hardSelect($sql);
        return $data;
    }

    public function getPages(){
        $query = $this->db->getData('users','COUNT(userID) as count')->where(array('userRemoved'=>0));
        $pages = $query->execute();
        $count = $pages[0]->count/$this->_perPage;
        return (ceil($count));
    }

    public function getUserByCookie($cookieVal){
        $query = $this->db->getData('users','*')->where('userCookies='.$cookieVal.' AND userRemoved = 0 AND userBanned = 0');
        $users = $query->execute();
        if(empty($users)){
            return false;
        }else{
            return $users[0];
        }
    }

    public function login(){
        $login = strip_tags(trim($_POST['email']));
        $password = strip_tags(trim($_POST['password']));
        $query = $this->db->getData('users','*')->where('userLogin='.$login.' AND userRemoved = 0 AND userBanned = 0');
        $users = $query->execute();
        if(empty($users)){
            $this->ajax->setResponse(false,5);
            $this->ajax->getResponse();
            return false;
        }
        $user = $users[0];
        unset($users);
        $DBfullPassword = $user->userPassword;
        $givenPassword = md5($password);
        if  ($givenPassword != $DBfullPassword){
            $this->ajax->setResponse(false,5);
            $this->ajax->getResponse();
            return false;
        }
        $generateCookie = md5(time()).$DBfullPassword.md5($login);
        $this->db->updateRecord('users', ['userCookies'=>$generateCookie], [ 'userID'=>$user->userID ] );
        $current = Current::getCurrent();
        $current->setUser($user);
        setcookie("RWT_E_UID", $generateCookie, time()+3600*12, '/');
        $this->ajax->setResponse(true,$user->userID);
        $this->ajax->getResponse();
        return true;
    }

    public function userUpdate($id){
        $userLogin = strip_tags(trim($_POST['userLogin']));
        $isBanned = intval($_POST['userBanned']);
        $userPermissions = intval($_POST['userPermissions']);
        $userPassword = md5($_POST['userPassword']);
        $userID = $id;

        $users = $this->db->hardSelect('SELECT userID FROM users WHERE userLogin="'.$userLogin.'" AND userID !="'.$userID.'"');
        if(!empty($users)){
            $this->ajax->setResponse(false,6);
            $this->ajax->getResponse();
            return false;
        }else{
            $previouslyBanned = $users[0]->userBanned;
            $data = array(
                'userLogin' => $userLogin,
                'userPermissions' => $userPermissions
            );
            if($_POST['userPassword']){
                $data['userPassword'] = $userPassword;
            }
            if($isBanned){
                $data['userBanned'] = time();
            }elseif($previouslyBanned && !$isBanned){
                $data['userBanned'] = 0;
            }else{
                $data['userBanned'] = $previouslyBanned;
            }
            $where = array(
                'userID' => $userID
            );
            $id = $this->db->updateRecord('users', $data, $where);
            $this->ajax->setResponse(true,$id);
            $this->ajax->getResponse();
            return true;
        }
    }

    public function userCreate(){
        $userLogin = strip_tags(trim($_POST['userLogin']));
        $userPermissions = intval($_POST['userPermissions']);
        $userPassword = md5($_POST['userPassword']);
        $userRegisterDate = time();

        $users = $this->db->hardSelect('SELECT userID FROM users WHERE (userLogin="'.$userLogin.'" OR userLogin ="'.$userLogin.'")');
        if(!empty($users)){
            $this->ajax->setResponse(false,6);
            $this->ajax->getResponse();
            return false;
        }else{
            //$previouslyBanned = $users[0]->userBanned;
            $data = array(
                'userLogin' => $userLogin,
                'userPermissions' => $userPermissions,
                'userPassword' => $userPassword,
                'userRegisterDate' => $userRegisterDate
            );
            $id = $this->db->insert('users', $data);
            $this->ajax->setResponse(true,$id);
            $this->ajax->getResponse();
            return true;
        }
    }

    public function userBan($id, $unBan = false){
        if(!$id){
            $this->ajax->setResponse(false,10);
            $this->ajax->getResponse();
            return false;
        }
        $query = $this->db->getData('users','*')->where(array('userID'=>$id));
        $data = $query->execute();
        $data = $data[0];
        if(!$data){
            $this->ajax->setResponse(false,10);
            $this->ajax->getResponse();
            return false;
        }else{
            $where = array(
                'userID' => $id
            );
            $data = array();
            if(!$unBan){
                $data['userBanned'] = time();
            }else{
                $data['userBanned'] = 0;
            }
            $id = $this->db->updateRecord('users', $data, $where);
            $this->ajax->setResponse(true,$id);
            $this->ajax->getResponse();
            return true;
        }
    }

    public function userRemove($id){
        if(!$id){
            $this->ajax->setResponse(false,11);
            $this->ajax->getResponse();
            return false;
        }
        $where = array(
            'userID' => $id
        );
        $data = array(
            'userRemoved'=> time()
        );
        $id = $this->db->updateRecord('users', $data, $where);
        $this->ajax->setResponse(true,$id);
        $this->ajax->getResponse();
        return true;
    }

}