<?php
/** @var $data **/
?>
<?php if(!empty($data)):?>
    <button class="btn btn-primary pull-right refresh-tags" style="margin-left:10px;"><i class="fa fa-refresh"></i> Sync Tags</button>
    <a href="/event/" class="btn btn-primary pull-right" style="margin-left:10px;"> Event list</a>
    <a href="/sessions/index/<?=$this->session->eventId?>" class="btn btn-primary pull-right" style="margin-left:10px;"> Session list</a>
    <div class="btn-group pull-right">
        <button type="button" class="btn btn-primary dropdown-toggle" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            Load From
        </button>
        <div class="dropdown-menu">
            <?php foreach($data as $session):?>
                <a class="dropdown-item load-from" data-session-id="<?=$session->id?>" href="#"><?=$session->fullDate;?></a>
            <?php endforeach; ?>
        </div>
    </div>

<?php endif;?>
<h2><?=$this->title?></h2>
<form method="post" id="create-session" class="loading-form" action=""  autocomplete="off">

    <div class="form-group">
        <label for="hotelName">Hotel Name:</label>
        <input required="required" type="text" id="hotelName" class="form-control" autocomplete="off" name="hotelName" value="<?=$this->session->hotelName?>"/>
    </div>

    <div class="form-group">
        <label for="street">Street:</label>
        <input required="required" type="text" id="street" class="form-control" autocomplete="off" name="street" value="<?=$this->session->street?>"/>
    </div>

    <div class="form-group">
        <label for="hotelPhone">Hotel Phone:</label>
        <input required="required" type="text" id="hotelPhone" class="form-control" autocomplete="off" name="hotelPhone" value="<?=$this->session->hotelPhone?>"/>
    </div>

    <div class="form-group">
        <label for="fullDate">Full Date (<a href="#" class="use-ph" data-target="fullDate">Use placeholder</a>):</label>
        <input required="required" type="text" id="fullDate" class="form-control" autocomplete="off" placeholder="Wednesday October 3, 2018 at 12:30 PM" name="fullDate" value="<?=$this->session->fullDate?>"/>
    </div>

    <div class="form-group">
        <label for="sessionChosen">Session Chosen For IFS (<a href="#" class="use-ph" data-target="sessionChosen">Use placeholder</a>):</label>
        <input required="required" type="text" id="sessionChosen" class="form-control" autocomplete="off" placeholder="2018-05-15 17:00:00" name="sessionChosen" value="<?=$this->session->sessionChosen?>"/>
    </div>

    <div class="form-group">
        <label for="tags">Session Tags <a href="#" class="clear-tags">(clear)</a>:</label>
        <?=View::generateSelect('tags',$this->tags,$this->session->tags,true,true,'selectpicker form-control')?>
    </div>

	<?php if($this->event->type == 'boot'):?>
    <div class="form-group">
        <label for="surveyForm">Survey Form:</label>
        <input type="text" id="surveyForm" class="form-control" autocomplete="off" name="surveyForm" value="<?=$this->session->surveyForm?>"/>
    </div>
	<?php endif;?>

	<?php if($this->event->type == 'live'):?>
        <div class="form-group">
            <label for="hours">Hours:</label>
            <textarea class="form-control" id="hours" rows="3"><?=$this->session->hours?></textarea>
        </div>
	<?php endif;?>

    <input type="hidden" name="id" id="id" value="<?=$this->id?>">
    <input type="hidden" name="eventId" id="eventId" value="<?=$this->session->eventId?>">

    <div class="create-field form-group">
        <input type="button" class="btn btn-primary" id="update" value="Update"/>
    </div>

</form>

<script>
    var allSessions = <?=json_encode($data);?>;
    loadFrom(allSessions);
    createSession(true);
    createSessionHelper();
    tagSync();
    selectPickerInit();

    $(document).ready(function(){
        var vals = '<?=$this->session->tags?>';
        if (vals != 0){
            var valsArr = vals.split(',');
            $('.selectpicker').selectpicker('val', valsArr);
        }

        $('.clear-tags').click(function(e){
            e.preventDefault();
            clearTags();
            return true;
        });
    });


</script>