<?php /**@var $data **/ ?>

<button data-event-id="<?=$this->eventId;?>" class="btn btn-primary pull-right refresh-stats"><i class="fa fa-refresh"></i> Sync Stats</button>
<h3><?=$this->title?></h3>
<div class="clearfix"></div>

<?php if(!$this->checkStats):?>

<h4 class="text-center" style="margin-top:50px;">Stats are empty or not synced</h4>

<?php else:?>

    <div class="card" style="margin-top: 30px;">
        <h3 class="card-header">Session stats</h3>
        <div class="card-body">
            <table class="table table-striped">
                <thead>
                <tr>
                    <th scope="col">Session</th>
                    <th scope="col">Registered</th>
                    <th scope="col">Confirmed</th>
                    <th scope="col">Confirmed%</th>
                    <th scope="col">Attended</th>
                    <th scope="col">Attended%</th>
                    <th scope="col">Purchased</th>
                    <th scope="col">Purchased%</th>
                </tr>
                </thead>
                <tbody>
		        <?php foreach($data['totalSessions'] as $row):?>
                    <tr>
                        <td scope="row"><?=$data['sessionNames'][$row->sessionId]?$data['sessionNames'][$row->sessionId]:$row->sessionId;?></td>
                        <td><?=$row->regSum;?></td>
                        <td><?=$row->confSum;?></td>
                        <td><?=$this->utility->calculatePercent($row->confSum,$row->regSum);?></td>
                        <td><?=$row->atSum;?></td>
                        <td><?=$this->utility->calculatePercent($row->atSum,$row->regSum);?></td>
                        <td><?=$this->getIFSlink($this->purchasedTag,$row->sessionId,$row->purSum)?></td>
                        <td><?=$this->utility->calculatePercent($row->purSum,$row->atSum);?></td>
                    </tr>
		        <?php endforeach;?>
                </tbody>
                <tfoot>
                <tr>
                    <th>Total</th>
                    <th><?=$data['total']->regSum;?></th>
                    <th><?=$data['total']->confSum;?></th>
                    <th><?=$this->utility->calculatePercent($data['total']->confSum,$data['total']->regSum);?></th>
                    <th><?=$data['total']->atSum;?></th>
                    <th><?=$this->utility->calculatePercent($data['total']->atSum,$data['total']->regSum);?></th>
                    <th><?=$this->getIFSlink($this->purchasedTag,-1,$data['total']->purSum)?></th>
                    <th><?=$this->utility->calculatePercent($data['total']->purSum,$data['total']->atSum);?></th>
                </tr>
                </tfoot>
            </table>
        </div>
    </div>

    <div class="card" style="margin-top: 30px;">
        <h3 class="card-header">Leadsource Stats</h3>
        <div class="card-body">


	                <?php foreach($data['leadsourceStats'] as $id => $session):?>
            <div class="card" style="margin-bottom:20px;">
                <div class="card-body">
                        <h5 class="card-title"><?=$data['sessionNames'][$id]?$data['sessionNames'][$id]:$id;?></h5>
                        <table class="table table-striped">
                            <thead>
                            <tr>
                                <th scope="col">Leadsource</th>
                                <th scope="col">Registered</th>
                                <th scope="col">Confirmed</th>
                                <th scope="col">Confirmed%</th>
                                <th scope="col">Attended</th>
                                <th scope="col">Attended%</th>
                                <th scope="col">Purchased</th>
                                <th scope="col">Purchased%</th>
                            </tr>
                            </thead>
                            <tbody>
                            <?php $sum = $this->getLeadsourceSum($session);?>
                            <?php if($sum>0):?>
                                <?php foreach($session as $leadsource => $row):?>
                                <?php if($row->regSum>0):?>
                                    <tr>
                                        <td scope="row"><?=$leadsource;?></td>
                                        <td><?=$row->regSum;?></td>
                                        <td><?=$row->confSum;?></td>
                                        <td><?=$this->utility->calculatePercent($row->confSum,$row->regSum);?></td>
                                        <td><?=$row->atSum;?></td>
                                        <td><?=$this->utility->calculatePercent($row->atSum,$row->regSum);?></td>
                                        <td><?=$row->purSum;?></td>
                                        <td><?=$this->utility->calculatePercent($row->purSum,$row->atSum);?></td>
                                    </tr>

                                <?php endif;?>
                                <?php endforeach;?>
                            <?php else:?>
                                <tr>
                                    <td>No Data</td>
                                    <td>No Data</td>
                                    <td>No Data</td>
                                    <td>No Data</td>
                                    <td>No Data</td>
                                    <td>No Data</td>
                                    <td>No Data</td>
                                    <td>No Data</td>
                                </tr>
                            <?php endif;?>
                            </tbody>
                        </table>
                </div>
            </div>
	                <?php endforeach;?>
    <div class="card">
        <div class="card-body">
            <h5 class="card-title">Total</h5>
            <table class="table table-striped">
                <thead>
                <tr>
                    <th scope="col">Leadsource</th>
                    <th scope="col">Registered</th>
                    <th scope="col">Confirmed</th>
                    <th scope="col">Confirmed%</th>
                    <th scope="col">Attended</th>
                    <th scope="col">Attended%</th>
                    <th scope="col">Purchased</th>
                    <th scope="col">Purchased%</th>
                </tr>
                </thead>
                <tbody>
		        <?php foreach($data['totalLeadsource'] as $row):?>
                    <tr>
                        <td><?=$row->leadsource;?></td>
                        <td><?=$row->regSum;?></td>
                        <td><?=$row->confSum;?></td>
                        <td><?=$this->utility->calculatePercent($row->confSum,$row->regSum);?></td>
                        <td><?=$row->atSum;?></td>
                        <td><?=$this->utility->calculatePercent($row->atSum,$row->regSum);?></td>
                        <td><?=$row->purSum;?></td>
                        <td><?=$this->utility->calculatePercent($row->purSum,$row->atSum);?></td>
                    </tr>
		        <?php endforeach;?>
                </tbody>
            </table>
        </div>
    </div>


        </div>
    </div>




<?php endif;?>