<?php

Class Route {
    private $controller = 'index';
    private $method = 'index';

    public function __construct() {

    }

    public function start() {

        $path = explode('?', $_SERVER['REQUEST_URI']);
        $path = explode('/', $path[0]);
        $result = array();
        $result[] = $this->checkRequest($path);
        $result[] = $this->checkController($path[1]);
        $result[] = $this->checkMethod($this->controller,$path[2]);

        if (in_array(false,$result)){
            $this->set404Error();
            return false;
        }

        if($this->controller == 'index'){
            $navController = '';
        }else{
            $navController = $this->controller;
        }
        if($this->method == 'index'){
            $navMethod = '';
        }else{
            $navMethod = $this->method;
        }

        $navigation = $navMethod == '' ? '/'.$navController.'/'.$navMethod:  '/'.$navController.'/'.$navMethod.'/';
        $navigation = $navigation == '//' ? '/' : $navigation;
        Current::setActiveNav($navigation);
        $current = new $this->controller();
        $method = $this->method;
        $current->$method();
        return true;
    }

    private function set404Error() {
        header('HTTP/1.1 404 Not Found');
        header("Status: 404 Not Found");
        require_once PAGE404;
    }

    private function checkController($name){
        $fileName = strtolower($name);
        if (file_exists(CONTROLLERS.$fileName.'.php')){
            $this->controller = $name;
            return true;
        }else if($name=='' || $name[0]=='?'){
            return true;
        }else{
            return false;
        }
    }

    private function checkMethod($controller,$method){
        $method = explode('?',$method);
        $method = $method[0];
        if (method_exists($controller,$method)){
            $this->method = $method;
        }else if(!method_exists($controller,$method) && !$method=='') {
            return false;
        }else if(!method_exists($controller,$method) && $method==''){
            return true;
        }else {
            return false;
        }
        return true;
    }

    private function checkRequest($path){
        if (!is_array($path) || empty($path)) {
            return false;
        } else{
            return true;
        }
    }


}