<?php
class Utility {

    protected $extensions = array(
        'jpg',
        'jpeg',
        'png',
        'bmp'
    );
    protected $videoExtensions = array(
        'mp4',
        'webm'
    );

    public function __construct(){
        return true;
    }

    /**
     * @param integer $number
     * @return mixed
     */
    public function getArgument($number){
        $pathParts = explode('/',CURRENT_LINK);
        $n = count($pathParts);
        $arguments = array();
        for ($i = 5; $i<$n; $i++){
            $arguments[]=$pathParts[$i];
        }
        $result = isset($arguments[$number]) ? $arguments[$number] : false;
        return $result;
    }

    /**
     * @param $param string
     * @return bool
     */
    public function getParam($param){
        return isset($_GET[$param]) ? $_GET[$param] : false;
    }

    /**
     * @param string $where
     * @param string $requestString
     */
    public function redirect($where,$requestString=''){
        if($where == 'self'){
            $where = CURRENT_LINK;
        }
        header('location:'.$where.$requestString);
    }

     /**
     * @param object $user
     * @param string $check
     * @return boolean
     */
    public function checkUserPermissions($user,$check){
        if($check == 'all'){
            return true;
        }
        $checking = explode(',',$check);
        $permToCheck = array();
        foreach($checking as $singlePermission){
            $permToCheck[] = trim($singlePermission);
        }
        unset($checking);
        if (in_array($user->userPermissions, $permToCheck)){
            return true;
        }else{
            return false;
        }
    }


    public function generateRandomName(){
        $symbols = 'abcdefghijklmnopqrstuvwxyz';
        return $symbols[rand(0,25)].$symbols[rand(0,25)].$symbols[rand(0,25)].time();
    }

    public function removeFile($file){
        if (file_exists($file)){
            unlink($file);
            return true;
        }else{
            return false;
        }
    }

	/**
	 * @param float $smaller
	 * @param float $bigger
	 * @param bool $addPercentSymbol
	 * @return float|int|string
	 */
    public function calculatePercent($smaller, $bigger, $addPercentSymbol = true){
    	if($bigger == 0){
    		return $addPercentSymbol ? '0%': 0;
	    }
    	$value = round(($smaller/$bigger)*100,2);
        return $addPercentSymbol ? $value.'%': $value;
    }

}